;;; Mode: Lisp; Package: cl-user

;;; Author: John Domingue

;;; The Open University

(in-package "CL-USER")

(setf (logical-pathname-translations "FOOD")
      
  `(("food:lisp;ocml;library;**;*"
     (concantenate 'string *current-pathname*
                   "code\\ocml\\library\\v5-0\\**\\*"))
    ("TOP;**;*"  ,(concatenate 'string *current-pathname* "**\\*"))
    ("top;**;*" ,(concatenate 'string *current-pathname* "**\\*"))
    ("PUBLIC-HTML;**;*" ,(concatenate 'string *current-pathname* "public_html\\**\\*"))
    ("PUBLIC-HTML;**;*" ,(concatenate 'string *current-pathname* "public_html\\**\\*"))
    ("LISP;**;*" ,(concatenate 'string *current-pathname* "code\\**\\*"))
    ("lisp;**;*" ,(concatenate 'string *current-pathname* "code\\**\\*"))
    ("CODE;**;*.*" ,(concatenate 'string *current-pathname* "code\\**\\*"))
    ("code;**;*.*" ,(concatenate 'string *current-pathname* "code\\**\\*"))
    ("SYSTEMS;**;*.*" ,(concatenate 'string *current-pathname* "code\\systems\\**\\*"))
    ("systems;**;*.*" ,(concatenate 'string *current-pathname* "code\\systems\\**\\*"))
    ("WEB;**;*" ,(concatenate 'string *current-pathname* "code\\http\\web\\**\\*"))
    ("web;**;*" ,(concatenate 'string *current-pathname* "code\\http\\web\\**\\*"))
    ("cedar;**;*" ,(concatenate 'string *current-pathname* "code\\cedar\\**\\*"))
    ("CEDAR;**;*" ,(concatenate 'string *current-pathname* "code\\cedar\\**\\*"))
    ("cedar-annotations;**;*" ,(concatenate 'string *current-pathname* "code\\cedar\\annotations\\**\\*"))
    
    ("private-patches;**;*" "c:\\Program Files\\Harlequin\\LispWorks\\private-patches\\**\\*")

    ("patches;**;*" "c:\\Program Files\\Harlequin\\LispWorks\\lib\\4-1-0-0\\patches\\**\\*")
    ;;("cedar-pages;**;*" "/systems/web_contents/main/docs/main_docs/cedar/**/*")
    ("cedar-pages;**;*" "D:/htdocs/**/*")
    ("bae-plans;**;*" "D:/htdocs/bae-plans/**/*")
    ("WEB-SERVER-PAGES;**;*" "c:\\program files\\apache group\\apache2\\htdocs\\**\\*")
    ("web-server-pages;**;*" "c:\\program files\\apache group\\apache2\\htdocs\\**\\*")
    ("personal-planet-pages;**;*" "c:\\program files\\apache group\\apache2\\htdocs\\planet\\personal\\**\\*")

    ("agnes-discussion-dir;**;*" "C:/Program Files/Apache Group/Apache/cgi-bin/**/*")
    ("AGNES-DISCUSSION-DIR;**;*" "C:/Program Files/Apache Group/Apache/cgi-bin/**/*")
    ("discussion;**;*" "/systems/web_contents/main/docs/cedar-discussion/**/*")
    ("DISCUSSION;**;*" "/systems/web_contents/main/docs/cedar-discussion/**/*")

    ("RELEASED;**;*" ,(concatenate 'string *current-pathname* "code\\**\\*"))
    ("released;**;*" ,(concatenate 'string *current-pathname* "code\\**\\*"))
    ("planet;phone-story;**;*" ,(concatenate 'string *current-pathname* "code\\planet-phone-stories\\**\\*"))
    ("PLANET-STORIES;**;*" ,(concatenate 'string *current-pathname* "code\\planet-stories\\**\\*"))
    ("planet-stories;**;*" ,(concatenate 'string *current-pathname* "code\\planet-stories\\**\\*"))
    ("PLANET-REGISTER;**;*" ,(concatenate 'string *current-pathname* "code\\planet-register\\**\\*"))
    ("planet-register;**;*" ,(concatenate 'string *current-pathname* "code\\planet-register\\**\\*"))
     ("RELEASED-PLANET-STORIES;**;*" ,(concatenate 'string *current-pathname* "code\\planet-stories\\**\\*"))
    ("released-planet-stories;**;*" ,(concatenate 'string *current-pathname* "code\\planet-stories\\**\\*"))
    ("RELEASED-PLANET-REGISTER;**;*" ,(concatenate 'string *current-pathname* "code\\planet-register\\**\\*"))
    ("released-planet-register;**;*" ,(concatenate 'string *current-pathname* "code\\planet-register\\**\\*"))
    
    ("RELEASED-PLANET-STORY-GIFS;**;*" 
     "c:\\program files\\apache group\\apache2\\htdocs\\planet\\gifs\\story-gifs\\**\\*")
    ("released-planet-story-gifs;**;*" "c:\\program files\\apache group\\apache2\\htdocs\\planet\\gifs\\story-gifs\\**\\*")
    ("magpie;**;*" "c:\\Magpie\\**\\*")
    ("magpie-ontology-store;**;*" "c:\\Magpie\\Ontology Store\\**\\*")
    ("pdf-to-html-converter;**;*" "C:\\Program Files\\pdftohtml-0.36\\**\\*")
    ("html-converter;**;*" "C:\\Program Files\\htmldoc\\**\\*")))
     

    

#+:HARLEQUIN-PC-LISP
(eval-when (eval compile load)
  (setf (logical-pathname-translations "UTIL")
      `(("EXPERIMENTAL;**;*" ,(concatenate 'string *current-pathname* "code\\util\\versions\\v7-1\\**\\*"))
        ("VERSION;V7-1;**;*" ,(concatenate 'string *current-pathname* "code\\util\\versions\\v7-1\\**\\*"))
        ("RELEASED;**;*" ,(concatenate 'string *current-pathname* "code\\util\\versions\\v7-1\\**\\*"))
        ))
  (setf (logical-pathname-translations "OCML")
        `(("VERSION;V7-1;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\versions\\v7-1\\**\\*"))
          ("VERSION;V7-2;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\versions\\v7-2\\**\\*"))
          ("VERSION;V7-3;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\versions\\v7-3\\**\\*"))
          ("VERSION;V7-0;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\versions\\v7-0\\**\\*"))
          ("EXPERIMENTAL;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\versions\\v7-3\\**\\*"))
          ("RELEASED;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\versions\\v7-3\\**\\*"))
          ("LIBRARY;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\library\\v5-0\\**\\*"))
          
          ("web;**;*" "C:\\htdocs\\ocml\\**\\*")
          ("ontolingua-web;**;*" "C:\\htdocs\\ontolingua\\**\\*")
          )))
        
      


(defvar *default-util-pathname* "UTIL:EXPERIMENTAL;")
(defvar *default-util-load-file* "UTIL:EXPERIMENTAL;SYSDCL")



(defvar *lisp-suffix*)

(eval-when (eval load)
  #+:LISPWORKS (setf *lisp-suffix* "lisp")
  #+:allegro (setf *lisp-suffix* "lisp")
  #+:mcl(setf *lisp-suffix* "lisp")
  #+:windows(setf *lisp-suffix* "lisp"))

(defvar *binary-suffix*)
  

(eval-when (eval load)
  #+:HARLEQUIN-PC-LISP (setf *binary-suffix* "fsl")
  #+allegro(setf *binary-suffix* "fasl")
  #+:mcl(setf *binary-suffix* "pfsl"))

 
(defun compile-file-if-necessary (file)
  (Let ((flag (or (not (probe-file (concatenate 'string file "." *binary-suffix*)))
                  (and (< (file-write-date (concatenate 'string file "." *binary-suffix*))
                          (file-write-date (concatenate 'string file "." *lisp-suffix*)))))))
    (when flag
      (compile-file  file :verbose t))))

(defun simple-load-system (files &optional compile? force?)
  (Let ((fun (if force?
               #'(lambda (x)
                   #-:HARLEQUIN-PC-LISP
                   (delete-file  (concatenate 'string x "." *binary-suffix*)
                                 :if-does-not-exist nil)
                   #+:HARLEQUIN-PC-LISP
                   (delete-file  (concatenate 'string x "." *binary-suffix*) nil)
                   (compile-file x :verbose t)
                   (load x :verbose t))
               (if compile?
                 #'(lambda (x)
                     (compile-file-if-necessary x)
                     (load x :verbose t))
                 #'(lambda (x) 
                     (load x :verbose t))))))
       
    (map nil fun 
        files)))

(eval-when (eval load)
  (push :webonto *features*))


#+:HARLEQUIN-PC-LISP
(eval-when (eval compile load)
  (setf (logical-pathname-translations "FREAKY-UTIL")
      `(("EXPERIMENTAL;**;*" ,(concatenate 'string *current-pathname* "code\\freaky\\util\\**\\*"))
        ))
  (setf (logical-pathname-translations "FREAKY")
        `(("EXPERIMENTAL;**;*" ,(concatenate 'string *current-pathname* "code\\freaky\\**\\*"))
          ("RELEASED;**;*" ,(concatenate 'string *current-pathname* "code\\freaky\\**\\*"))
          ("LIBRARY;**;*" ,(concatenate 'string *current-pathname* "code\\ocml\\library\\v5-0\\**\\*"))
          ("RDF-FILES;**;*" ,(concatenate 'string *current-pathname* "code\\freaky\\rdf-files\\**\\*")))))




#+:mcl
(eval-when (eval compile load)
  (setf (logical-pathname-translations "FREAKY") 
      `(("EXPERIMENTAL;**;*" "Stuff:Users:Enrico:Recent Stuff:code:freaky:**:*")
        ("RELEASED;**;*" "Stuff:Users:Enrico:Recent Stuff:code:freaky:**:*")
        ("LIBRARY;**;*" "Stuff:Users:Enrico:Recent Stuff:code:freaky:library:**:*")
        ("RDF-FILES;**;*" "Stuff:Users:Enrico:Recent Stuff:code:freaky:rdf-files:**:*"))))

#+:harlequin-pc-lisp
(eval-when (eval compile load)
  (setf (logical-pathname-translations "wilbur")
      
  `(("core;**;*"  ,(concatenate 'string *current-pathname* "code\\wilbur\\core\\source\\**\\*"))
    ("load;**;*"  ,(concatenate 'string *current-pathname* "code\\wilbur\\core\\**\\*"))
    ("schemata;**;*"  ,(concatenate 'string *current-pathname* "code\\wilbur\\core\\shemata\\**\\*")))))