(in-package :http)

(add-lispweb-service :cookies
		     :description "Support for Netscape cookies.")

					; http://home.netscape.com/newsref/std/cookie_spec.html"

(defstruct cookie
  name
  val
  expires
  path
  domain
  secure)

(defun create-cookie (name value &key expires
				      path
				      domain
				      secure)
  (make-cookie :name name
	       :val value
	       :expires expires
	       :path path
	       :domain domain
	       :secure secure))

(defun format-cookie (cookie)
  (format nil "~a=~a~:[~;; Expires=~:*~a~]~:[~;; Path=~:*~a~]~:[~;; Domain=~:*~a~]~:[~;; Secure~]" 
	  (cookie-name cookie)
	  (cookie-val cookie)
	  (cookie-expires cookie)
	  (cookie-path cookie)
	  (cookie-domain cookie)
	  (cookie-secure cookie)))

(defun cookie-field (cookie)
  (format nil "Set-cookie: ~a" (format-cookie cookie)))

(defun cookie-meta (cookie)
  (list :http-equiv "Set-cookie" :content (format-cookie cookie)))

(defun cookie-value ()
  (header-value :cookie))

(defun cookie-values ()
  (header-values :cookie))
