;;; -*- Mode:Lisp; Base:10; Package: user -*-

;;; File: top.lisp
;;; Program: 

;;; Author: Alberto Riva (alb@ipvaim.unipv.it)
;;; Created: Thu Aug 31, 1995
;;; Description: 

;;; Contents:
;;; -*- -*-

(in-package :user)

#+ALLEGRO(list 'ipc::start-lisp-server-process 'ipc::unix-close)

(defvar *tcp-exported-symbols*
    '("SOCKET-FD" "CLOSE-TCP-STREAM" "CRYPT" "SOCKET-FD" "CLOSE-TCP-STREAM" "GET-HOST-BY-ADDR" "GET-HOST-BY-NAME" "TELNET" "SEND-MAIL"
      "LISP-HTTP-SERVER" "START-TELNET-SERVER"))

(defvar *html-exported-symbols* 
    '("ADDRESS" "ANCHOR" "APPLET" "AREA" "BETWEEN" "BLINK" "BLOCKQUOTE" "BOLD" "BUTTON" "CAPTION" "CENTER" "CHECKBOX" "CITATION"
      "CLIENT-SIDE-MAP" "CODE" "COLOR-STRING" "COMMENT" "COORDS-TO-STRING" "DEFINE-PAGE-STYLE" "DEFINITION-LIST" "DOTTED-LIST" 
      "EMPHASIZED" "FILENAME-FIELD" "FIXED" "FONT" "FORMAT-HTTP-INFO" "FRAME" "FRAMESET" "HEADER" "HIDDEN-FIELD" "HIERARCHY" 
      "HRULE" "HTML-BUILD" "HTML-OUT" "HTML-PPRINT" "HTML-STREAM" "IMAGE-BUTTON" "IMAGE-MAP" "IN-FORM" "IN-TABLE" "INCLUDE" 
      "INLINE-GD" "INLINE-IMAGE" "ITALIC" "JAVASCRIPT" "KEYBOARD" "LIST-TO-TABLE" "LISTING" "LR-TREE" "MENU" "MENU-SELECT" 
      "NOBREAK" "NOFRAMES" "NUMBERED-LIST" "PAGE-ANCHOR" "PAGE-STYLE-ALINK" "PAGE-STYLE-AUTH" "PAGE-STYLE-BACKGROUND" 
      "PAGE-STYLE-BGCOLOR" "PAGE-STYLE-CODE" "PAGE-STYLE-COOKIE" "PAGE-STYLE-LINK" "PAGE-STYLE-META" "NOSCRIPT"
      "PAGE-STYLE-TEXT" "PAGE-STYLE-VLINK" "PASSWORD-FIELD" "PLAINTEXT" "PREFORMATTED" "RADIO-BUTTON" "REDIRECT-META" "REFERENCE"
      "REFRESH-META" "REGISTER-TOP-LEVEL-LINK" "REGISTER-USER-FORM" "REGISTER-USER-GD" "RESET-BUTTON" "SAMPLE" "SOURCE-PAGE-BUTTON" 
      "STRIKE" "STRONG" "SUBMIT-BUTTON" "SUBSCRIPT" "SUPERSCRIPT" "TABLE-CELL" "TABLE-HEADER" "TABLE-ROW" "TEXT-AREA" "TEXT-FIELD" 
      "VAR" "WITH-FORM-FIELDS" "WITH-OUTPUT-TO-HTTP" "CALL-PAGE"))
    
(defvar *http-exported-symbols*
    '("*LISPWEB-BASE-HEADER*" "*LISPWEB-BANNER*" "*LISPWEB-BUILD-DATE*" "*LISPWEB-CONF-DIR*" "*LISPWEB-DEBUG-FILE*" 
      "*LISPWEB-DEBUG-STREAM*" "*LISPWEB-HALL-DEMO*" "*LISPWEB-HTML-INDENT*" "*LISPWEB-JS-LIBRARY*" "*LISPWEB-LOG-FILE*" 
      "*LISPWEB-LOG-STREAM*" "*LISPWEB-SERVICES*" "*LISPWEB-TIMING-FILE*" "*LISPWEB-TIMING-STREAM*" "*LISPWEB-VERSION*" 
      "*CLOSING-SERVER*" "*CONNECTION-ADDRESS*" "*EVAL-PORT*" "*EVAL-SOCKET*" "*EVAL-STREAM*" "*HTTP-CONNECTION*" 
      "*HTTP-DELAY*" "*HTTP-INFO*" "*HTTP-MULTITHREADED-P*" "*HTTP-PORT*" "*HTTP-SOCKET*" "*HTTP-STREAM*" "*LISTENER-CONNECTION*" 
      "*OPERATOR-ADDRESS*" "*OPERATOR-PASSWORD*" "*REQUEST-COUNTER*" "*STARTUP-DATE*" "*SYSTEM-PAGES*" "*STATUS-CODE-ALIST*"
      "*TOP-LEVEL-LINKS*" "*USER-PAGES*" "ADD-OBJ" "ADD-LISPWEB-SERVICE" "CHECK-AUTH" "CHECK-PASSWORD" "CLOSE-STREAMS" "DEFINE-APPLICATION"
      "DEFINE-GD" "DEFINE-NO-PAGE" "DEFINE-PAGE" "DEFINE-PAGE2" "DEFUN-HALL" "ENCRYPT-PASSWORD" "EXPLODE-REQUEST" "HALL-ARGLIST" "HEADER-VALUE"
      "HEADER-VALUES" "HTTP-DEBUG-MESSAGE" "HTTP-INFO-ADDR" "HTTP-INFO-BROWSER" "HTTP-INFO-FD" "HTTP-INFO-FIELDS" "HTTP-INFO-HEADERS"
      "HTTP-INFO-METHOD" "HTTP-INFO-PROTOCOL" "HTTP-INFO-REQUEST" "HTTP-INFO-REQUEST-COUNTER" "HTTP-INFO-REQUEST-OBJECT" 
      "HTTP-INFO-ARGUMENTS" "HTTP-INFO-SOCKET" "HTTP-INFO-REQUEST-LINE" "LW-LOG" "LW-SET-LOG"
      "HTTP-INFO-STREAM" "HTTP-LOG-MESSAGE" "HTTP-READ-LINE" "HTTP-REPLY" "HTTP-TIME" "INIT-SERVER" "INIT-STREAMS" "JS-WINDOW-OPTIONS"
      "LISPWEB-PATH" "LOAD-INIT-FILE" "LW-DEBUG" "MAKE-HTTP-INFO" "ORDERED-PUSH" "PROCESS-REQUEST" "PROCESS-HEADERS" "REGION-COND"
      "REGISTER-JAVA-APPLET" "REGISTER-SYSTEM-PAGE" "REGISTER-USER-PAGE" "SAFE-READNUM" "SEND-MAIL" "SET-FORM-VALUES" "TASK-NAME"
      "TEST-ACCESS-KEY" "TEXT-HEADER" "URL" "WITH-FIELD-VALUE" "WITH-FIELD-VALUES" "WITH-HTML-INDENT" "LISPWEB-PAGE-KEY" "FIND-KEY"
      "ACCESS-KEY-HOST" "FORM-VALUE"))

(defpackage :gd
  #+LUCID(:use :lisp :lcl)
  #+ALLEGRO(:use :lisp)
  #+LISPWORKS(:use :lisp)
  )

(defpackage :tcp
  #+LUCID(:use :lisp :lcl)
  #+ALLEGRO(:use :lisp :ipc :ff)
  #+ALLEGRO(:import-from :ipc ipc::start-lisp-server-process ipc::unix-close)
  #+LISPWORKS(:use :lisp)
  )

(defpackage :html
  #+LUCID(:use :lisp :lcl)
  #+ALLEGRO(:use :lisp)
  #+LISPWORKS(:use :lisp)
  )

(defpackage :http
  #+LUCID(:use :lisp :html :lcl)
  #+ALLEGRO(:use :lisp :excl :html :tcp)
  #+LISPWORKS(:use :lisp :html :tcp)
  )

(eval-when (load eval)
  (export (mapcar #'(lambda (s)
		      (intern s :tcp))
		  *tcp-exported-symbols*)
	  :tcp)
  (export (mapcar #'(lambda (s)
		      (intern s :html))
		  *html-exported-symbols*)
	  :html)
  (export (mapcar #'(lambda (s)
		      (intern s :http))
		  *http-exported-symbols*)
	  :http))

(defpackage :stsp
  #+LUCID(:use :lisp :http :html :lcl)
  #+ALLEGRO(:use :lisp :http :html)
  #+LISPWORKS(:use :lisp :http :html)
  (:export *stsp-version* *stsp-tasks* define-task find-task find-task-action define-task-action with-stsp stsp-error stsp-header))

(defpackage :lispweb-user
  (:nicknames :lu)
  #+LUCID(:use :lisp :html :http :lcl)
  #+ALLEGRO(:use :lisp :html :http)
  #+LISPWORKS(:use :lisp :html :http))

(eval-when (load eval)
  (export (mapcar #'(lambda (s)
		      (intern s :http))
		  *http-exported-symbols*)
	  :lispweb-user)
  (export (mapcar #'(lambda (s)
		      (intern s :html))
		  *html-exported-symbols*)
	  :lispweb-user))

(defpackage :stsp-user
  (:nicknames :su)
  #+LUCID(:use :lisp :stsp :http :lcl)
  #+ALLEGRO(:use :lisp :stsp :http)
  #+LISPWORKS(:use :lisp :stsp :http)
  (:export *stsp-version* *stsp-tasks* define-task find-task find-task-action define-task-action with-stsp stsp-error))

(defvar *http-to-html-imports*
    '("*LISPWEB-HALL-DEMO*"
      "*LISPWEB-HTML-INDENT*"
      "*LISPWEB-SERVICES*"
      "*HTTP-INFO*"
      "*HTTP-STREAM*"
      "ADD-OBJ"
      "ADD-LISPWEB-SERVICE"
      "CHECK-AUTH"
      "DEFUN-HALL"
      "HTTP-INFO-ADDR"
      "HTTP-INFO-BROWSER"
      "HTTP-INFO-FD"
      "HTTP-INFO-FIELDS"
      "HTTP-INFO-HEADERS"
      "HTTP-INFO-METHOD"
      "HTTP-INFO-PROTOCOL"
      "HTTP-INFO-REQUEST-COUNTER"
      "HTTP-INFO-REQUEST-LINE"
      "HTTP-INFO-REQUEST-OBJECT"
      "HTTP-INFO-SOCKET"
      "HTTP-TIME"
      "LISPWEB-PAGE-KEY"
      "LISPWEB-PATH"
      "REGISTER-SYSTEM-PAGE"
      "REGISTER-USER-PAGE"
      "TEXT-HEADER"
      "URL"
      "WITH-HTML-INDENT"))

(eval-when (load eval)
  (import (mapcar #'(lambda (s)
		      (find-symbol s :http))
		  *http-to-html-imports*)
	  :html))
  
(eval-when (load eval)
  #+ALLEGRO(import 'excl::gc :http)
  (import 'stsp:*stsp-tasks* :lu))

(eval-when (compile)
  (proclaim '(inline http::http-read-line)))


