;;; Mode: Lisp; Package: ocml

;;; Author: John Domingue

;;; The Open University

(in-package "OCML")

(in-ontology wsmo)




(DEF-CLASS RUN-OCML-EXPRESSION-GOAL-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)


(DEF-CLASS RUN-OCML-EXPRESSION-GOAL
           (GOAL)
           ?GOAL
           ((HAS-INPUT-ROLE :VALUE HAS-VARIABLES :VALUE HAS-EXPRESSION)
            (HAS-INPUT-SOAP-BINDING
             :VALUE
             (HAS-VARIABLES "sexpr")
             :VALUE
             (HAS-EXPRESSION "sexpr"))
            (HAS-OUTPUT-ROLE :VALUE HAS-EVALUATION-RESULT)
            (HAS-OUTPUT-SOAP-BINDING
             :VALUE
             (HAS-EVALUATION-RESULT "sexpr"))
            (HAS-VARIABLES :TYPE LIST)
            (HAS-EXPRESSION :TYPE LIST)
            (HAS-EVALUATION-RESULT :TYPE EXPRESSION)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             RUN-OCML-EXPRESSION-GOAL-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE
           (WEB-SERVICE)
           ?WEB-SERVICE
           ((HAS-CAPABILITY
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-CAPABILITY)
            (has-internal-method :value irs-run-ocml-expression)
            (HAS-INTERFACE
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-CAPABILITY-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-CAPABILITY
           (CAPABILITY)
           ?CAPABILITY
           ((USED-MEDIATOR :VALUE UN-OCML-EXPRESSION-MEDIATOR)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-CAPABILITY-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-CHOREOGRAPHY
           (CHOREOGRAPHY)
           ((HAS-GROUNDING :VALUE ((NORMAL DUMMY-FUNCTION)))))

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN
           (PROBLEM-SOLVING-PATTERN)
           NIL)

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-ORCHESTRATION
           (ORCHESTRATION)
           ((HAS-PROBLEM-SOLVING-PATTERN
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-ORCHESTRATION-PROBLEM-SOLVING-PATTERN)))

(DEF-CLASS RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE
           (INTERFACE)
           ?INTERFACE
           ((HAS-CHOREOGRAPHY
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-CHOREOGRAPHY)
            (HAS-ORCHESTRATION
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-ORCHESTRATION)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE-INTERFACE-NON-FUNCTIONAL-PROPERTIES)))

(DEF-CLASS RUN-OCML-EXPRESSION-MEDIATOR-NON-FUNCTIONAL-PROPERTIES
           (NON-FUNCTIONAL-PROPERTIES)
           NIL)

(DEF-CLASS RUN-OCML-EXPRESSION-MEDIATOR
           (WG-MEDIATOR)
           ?MEDIATOR
           ((HAS-SOURCE-COMPONENT :VALUE RUN-OCML-EXPRESSION-GOAL)
            (HAS-TARGET-COMPONENT
             :VALUE
             RUN-OCML-EXPRESSION-WEB-SERVICE)
            (HAS-NON-FUNCTIONAL-PROPERTIES
             :VALUE
             RUN-OCML-EXPRESSION-MEDIATOR-NON-FUNCTIONAL-PROPERTIES)))