;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology amazon-search-psm-ontology)



(def-class search-book-psm
           (primitive-method)
           ?psm
           ((has-input-role
             :value
             tag
             :value
             devt
             :value
             authorsearch
             :value
             mode
             :value
             type
             :value
             page
             :value
             format)
            (has-output-role :value result)
            (tag :type string)
            (devt :type string)
            (authorsearch :type string)
            (mode :type string)
            (type :type string)
            (page :type string)
            (format :type string)
            (result :type string))
           :own-slots
           ((tackles-task-type search-book-task)))


(def-class amazon-search-psm
           (primitive-method)
           ?psm
           ((has-input-role
             :value
             has-query
             :value
             has-search-type
             :value
             has-product-type)
            (has-output-role :value has-search-result)
            (has-query :type string)
            (has-search-type :type amazon-search-type)
            (has-product-type :type amazon-product)
            (has-search-result :type string)))

(def-class amazon-book-author-search-psm (amazon-search-psm) ?psm 
  ()
  :own-slots ((tackles-task-type amazon-search-task)
              (applicability-condition 
               (kappa (?psm) 
                      (and (amazon-book-type (role-value ?psm has-product-type))
                           (author-search-type (role-value ?psm has-search-type)))))))


(def-class amazon-book-keyword-search-psm (amazon-search-psm) ?psm 
  ()
  :own-slots ((tackles-task-type amazon-search-task)
              (applicability-condition 
               (kappa (?task)
                      (and (amazon-book-type (role-value ?task has-product-type))
                           (keyword-search-type (role-value ?task has-search-type)))))))


(def-class amazon-video-actor-search-psm
           (amazon-search-psm)
           ?psm
           nil
           :own-slots
           ((applicability-condition
             (kappa
              (?task)
              (and (amazon-video-type
                    (role-value ?task has-product-type))
                   (actor-search-type
                    (role-value ?task has-search-type)))))
            (tackles-task-type amazon-search-task)))
  


#|
                      ))))


                      (and (amazon-book-type (role-value ?task has-product-type))
                           (author-search-type (role-value ?task has-search-type)))
|#


