;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology exchange-rate-provider-ontology)

(defun of-string-type-p (type x)
  (holds? type (if (stringp x)
                   (intern (string-upcase x)
                           (find-package "OCML"))
                 x)))

(defun european-string-currency-p (currency)
  (of-string-type-p 'european-currency currency))

(defun non-european-string-currency-p (currency)
  (of-string-type-p 'non-european-currency currency))


(def-relation european-currency-string (?currency)
  :argument-types (currency)
  :lisp-fun
  #'(lambda (currency env)
      (Let ((result (european-string-currency-p currency)))
        (if result 
            (List 'true)
          :fail))))

(def-relation non-european-currency-string (?currency)
  :argument-types (currency)
  :lisp-fun
  #'(lambda (currency env)
      (declare (ignore env))
      (Let ((result (non-european-string-currency-p currency)))
        (if result 
            (List 'true)
          :fail))))
