;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology exchange-rate-provider-ontology)


(def-class exchange-rate-provider
           (primitive-method)
           ?psm
           ((has-input-role
             :value
             has_source_currency
             :value
             has_target_currency)
            (has-output-role :value has-exchange-rate)
            (has_source_currency :type currency)
            (has_target_currency :type currency)
            (has-exchange-rate :type positive-number)
            (has-precondition
             :value
             (kappa
              (?psm)
              (and (currency (role-value ?psm has_source_currency))
                   (currency (role-value ?psm has_target_currency)))))))


(def-class european-exchange-rate-provider
           (exchange-rate-provider)
           ?psm ()
           :own-slots
           ((applicability-condition
             (kappa
              (?psm)
              (european-currency-string
               (role-value ?psm 'has_source_currency))))
            (tackles-task-type exchange_rate_provision)))

(def-class non-european-exchange-rate-provider
           (exchange-rate-provider)
           ?psm
           nil
           :own-slots
           ((applicability-condition
             (kappa
              (?psm)
              (non-european-currency-string
               (role-value ?psm 'has_source_currency))))
            (tackles-task-type exchange_rate_provision)))