;;; Mode: Lisp; Package: ocml

;;; The Open University

(in-package "OCML")


(in-ontology GenericCurrencyConverter)



(def-class generic_currency_converter  (primitive-method) ?psm
  ((has-input-role :value has_source_currency 
                   :value has_target_currency
                   :value has_amount
                   )
   (has-output-role :value has_currency_conversion )
   (has_source_currency :type currency :cardinality 1)
   (has_target_currency :type currency :cardinality 1)
   (has_amount :type positive-number)
   (has_currency_conversion :type positive-number)
   (has-precondition 
    :value (kappa (?psm)
                  (and (positive-number (role-value ?psm has_amount))
                       (currency (role-value ?psm has_source_currency))
                       (currency (role-value ?psm has_target_currency)))))
   (has-postcondition 
    :value (kappa (?psm ?sol)
                  (currency_conversion ?sol (role-value ?psm has_source_currency) 
                                       (role-value ?psm has_target_currency)
                                       (role-value ?psm has_amount))))
   (has-body 
    :value (lambda (?psm)
             (*  (role-value ?psm has_amount)
                 (achieve-generic-task 'exchange_rate_Provision
                                         (list-of (List-of has_source_currency 
                                                           (role-value ?psm has_source_currency))
                                                  (List-of has_target_currency 
                                                           (role-value ?psm has_target_currency))))))))

;;(lambda (?psm)
;;             (*  (role-value ?psm has_amount)
;;                 (the_exchange_rate (role-value ?psm has_source_currency)
;;                                    (role-value ?psm has_target_currency))))))
  :own-slots ((tackles-task-type   generic_currency_conversion)))



