;;; Mode: Lisp; Package: ocml

;;; File created in WebOnto

(in-package "OCML")

(in-ontology planetonto-psm-ontology)


(def-class search-task
           (goal-specification-task)
           ?task
           ((has-input-role :value search-item)
            (has-output-role :value news-items)
            (search-item :type thing)
            (news-items :type list)))

(def-irs-soap-bindings search-task
                       planetonto-psm-ontology
                       ((search-item "sexpr"))
                       "sexpr")

(def-class person-search-psm
           (primitive-method)
           ?psm
           ((has-input-role :value search-item)
            (has-output-role :value news-items)
            (search-item :type thing)
            (news-items :type list))
           :own-slots
           ((applicability-condition
             (kappa (?psm) (person (role-value ?psm search-item))))
            (tackles-task-type search-task)))

(def-class person-type-search-psm
           (primitive-method)
           ?psm
           ((has-input-role :value search-item)
            (has-output-role :value news-items)
            (search-item :type thing)
            (news-items :type list))
           :own-slots
           ((applicability-condition
             (kappa
              (?psm)
              (person-type (role-value ?psm search-item))))
            (tackles-task-type search-task)))

(def-class myplanet-task
           (goal-specification-task)
           ?task
           ((has-input-role :value profile-name :value has-items)
            (has-output-role :value myplanet-url)
            (profile-name :type individual)
            (has-items :type list)
            (myplanet-url :type url)))

(def-irs-soap-bindings myplanet-task
                       planetonto-psm-ontology
                       ((profile-name "sexpr")
                        (has-items "sexpr"))
                       "sexpr")

(def-class myplanet-psm
           (primitive-method)
           ?psm
           ((has-input-role :value profile-name :value has-items)
            (has-output-role :value myplanet-url)
            (profile-name :type individual)
            (has-items :type list)
            (myplanet-url :type url))
           :own-slots
           ((tackles-task-type myplanet-task)))

(def-class myplanet-task2
           (goal-specification-task)
           ?task
           ((has-input-role :value profile-name :value has-items)
            (has-output-role :value related-items)
            (profile-name :type individual)
            (has-items :type list)
            (related-items :type list)))

(def-irs-soap-bindings myplanet-task2
                       planetonto-psm-ontology
                       ((profile-name "sexpr")
                        (has-items "sexpr"))
                       "sexpr")

(def-class myplanet-psm2
           (primitive-method)
           ?psm
           ((has-input-role :value has-items :value profile-name)
            (has-output-role :value related-items)
            (has-items :type list)
            (profile-name :type individual)
            (related-items :type list))
           :own-slots
           ((tackles-task-type myplanet-task2)))

(def-class list-repositories
           (goal-specification-task)
           ?task
           ((has-input-role :value has-name)
            (has-output-role :value repositories)
            (has-name :type string)
            (repositories :type string)))

(def-irs-soap-bindings list-repositories
                       planetonto-psm-ontology
                       ((has-name "sexpr"))
                       "sexpr")

(def-class lp-psm
           (primitive-method)
           ?psm
           ((has-input-role :value has-name)
            (has-output-role :value repositories)
            (has-name :type string)
            (repositories :type string))
           :own-slots
           ((tackles-task-type list-repositories)))