;;; -*- Mode: LISP; Syntax: Common-lisp; Base: 10; Package: OCML;   -*-

(in-package "OCML")


(in-ontology propose&revise)

(def-class PROPOSE&REVISE (design-method)
  ((has-input-role :value has-design-fixes 
                   :value has-design-procedures)
   (has-design-procedures :type design-procedure)
   (has-design-fixes :type design-fix))
  :lisp-class-name propose&revise)


(def-class FIXABLE-PARAMETRIC-CONSTRAINT (parametric-constraint)
  "A fixable parametric constraint is a parametric constraint which
   can be fixed by some relevant design fixes"
   :Lisp-slots ((relevant-operators :accessor relevant-operators
                                    :initform nil))
    :lisp-class-name  FIXABLE-PARAMETRIC-CONSTRAINT)


(def-class DESIGN-PROCEDURE (design-extension-operator)
   :lisp-class-name design-procedure)

(def-class DESIGN-FIX (design-modification-operator)
  "A basic design fix is a basic design modification operator which is associated
   with a fixable parametric constraint"
  ((applicable-to-constraints :type function-expression
                              :documentation "An expression which returns the set
                                              of constraints which can be fixed by 
                                              this fix"))
  :lisp-slots ((effective-constraint-list 
                                         :initform nil
                                         :accessor effective-constraint-list))
   :lisp-class-name design-fix)


(def-class BASIC-DESIGN-PROCEDURE (design-procedure basic-design-extension-operator)
  "Essentially another name for a basic design extension operator"
   :lisp-class-name basic-design-procedure)

(def-class MULTI-VALUED-DESIGN-PROCEDURE (design-procedure 
                                          multi-valued-design-extension-operator)
  "Essentially another name for a multi-valued design extension operator"
   :lisp-class-name multi-valued-design-procedure)



(def-class BASIC-DESIGN-FIX (design-fix basic-design-modification-operator)
  "A basic design fix is a basic design modification operator which is associated
   with a fixable parametric constraint"
  :lisp-class-name basic-design-fix)

(def-class MULTI-VALUED-DESIGN-FIX (design-fix 
                                    multi-valued-design-modification-operator)
  "A multi-valued design fix is a multi-valued design modification operator 
   which is associated with a fixable parametric constraint"
  :lisp-class-name multi-valued-design-fix)