;;; -*- Mode: LISP; Syntax: Common-lisp; Base: 10; Package: OCML;   -*-

(in-package "OCML")



(in-ontology propose-revise-improve)

(def-class PROPOSE-REVISE-IMPROVE (propose&improve propose&revise)
  :lisp-slots ((design-state-type :initform 'p-r-i-design-state)
               )
   :lisp-class-name PROPOSE-REVISE-IMPROVE)

(defclass P-R-I-DESIGN-STATE (P&I-DESIGN-STATE)())



(defmethod DESIGN-FROM-STATE (appl (method propose-revise-improve) 
                                   (state P-R-I-DESIGN-STATE))
  (if (state-feasible? state)
    (if (violated-constraints state)
      (revise-design appl method state)
      (if (state-complete? state)
        (cond ((state-complete? (predecessor state))
               (if (and (cheaper-cost? (state-cost state)
                                       (state-cost (predecessor state)))
                        (> (improvement-margin (state-cost (predecessor state)) (state-cost state))
                           *cost-improvement-measure*))
                 (improve-design appl method state)
                 (state-fails state)))
              (t
               (when (new-state? state)
                 (print-with-spaces (state-depth state)
                                    "Design is now complete..trying to improve solution..."))
               (improve-design appl method state)))
        (extend-design appl method state)))
    (state-fails state)))


