;;; -*- Mode: LISP; Syntax: Common-lisp; Base: 10; Package: ocml;   -*-

(in-package ocml)

(defun ocml-warn (string &rest format-args)
  (format t "~2%Warning: ~s~%"
          (apply #'format nil (cons string format-args))))
;;  (apply #'warn (cons string format-args)))

(defun ocml-output (string &rest format-args)
  (apply #'format t  string format-args))

(defun ocml-record-source-file (name type &optional ontology)
  (when (and (null ontology)
             *ocml-initialized*)
    (setf ontology (name *current-ontology*)))
  #+:mcl (CCL:RECORD-SOURCE-FILE name type)
  #+:lispworks (eval `(lw::top-level-form (,type ,name ,ontology) nil))
  #+:allegro(cl-user::record-source-file name :type type))

(defun ocml-record-instance-source-file (name parent type &optional ontology)
  parent ;;ignore
  (when (and (null ontology)
             *ocml-initialized*)
    (setf ontology (name *current-ontology*)))
  #+:mcl (CCL:RECORD-SOURCE-FILE name type)
  #+:lispworks (eval `(lw::top-level-form (,type ,name ,parent ,ontology) nil))
  #+:allegro(cl-user::record-source-file name :type type))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 #+:lispworks(eval-when (eval load)
               ;;;;;;;;;;(editor::setup-indent 'def-role 1 4 4)
               (editor::setup-indent 'def-rule 1 4 4))