package org.infrawebs.axiom.editor;

import java.util.List;

import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.editparts.AbstractEditPart;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.ui.IEditorPart;
import org.infrawebs.axiom.model.Compactable;
import org.infrawebs.axiom.model.commands.ChangeCompactCommand;

class AxiomEditDomain extends DefaultEditDomain {
	AxiomEditDomain(IEditorPart editorPart) {
		super(editorPart);
	}
	
	@Override
	public void mouseDoubleClick(MouseEvent mouseEvent, EditPartViewer viewer) {
		super.mouseDoubleClick(mouseEvent, viewer);
		List list = viewer.getSelectedEditParts();
		if (list.size() != 1) {
			return;
		}
		AbstractEditPart part = (AbstractEditPart)list.get(0);
		if (part.getModel() instanceof Compactable) {
			Compactable model = (Compactable)part.getModel(); 
			getCommandStack().execute(new ChangeCompactCommand(model));
		}
	}
}