package org.infrawebs.axiom.editor.actions.connections;

import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.model.ConnectionModel;
import org.infrawebs.axiom.model.OperatorModel;

public class InsertOperatorAndAction extends InsertOperatorAction
{
	public InsertOperatorAndAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	protected boolean calculateEnabled() {
		if (super.calculateEnabled() == false) {
			return false;
		}
		ConnectionModel conn = (ConnectionModel)this.getSelectedModel();
		// Do not insert an AND on connections already ending in an AND.

		// Do not insert an AND on connection chains originating from refinables.
		// TODO: what about (NOT a) AND (NOT b) AND Relation(c, d) ?
		return !isAnyEndSameOperator(conn) && (conn.getSource().listChainOrigins().size() == 0);
	}

	@Override
	protected int getOperatorType() {
		return OperatorModel.OPERATOR_AND;	
	}
}
