package org.infrawebs.axiom.editor.actions.connections;

import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.model.ConnectionModel;
import org.infrawebs.axiom.model.OperatorModel;

public class InsertOperatorNotAction extends InsertOperatorAction
{
	public InsertOperatorNotAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	protected boolean calculateEnabled() {
		if (super.calculateEnabled() == false) {
			return false;
		}
		ConnectionModel conn = (ConnectionModel)this.getSelectedModel();
		// Do not insert a NOT on connections already ending in a NOT.
		return !isAnyEndSameOperator(conn);
	}

	@Override
	protected int getOperatorType() {
		return OperatorModel.OPERATOR_NOT;	
	}
}
