package org.infrawebs.axiom.editor.actions.contents;

import org.infrawebs.axiom.editor.actions.AxiomAction;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.AxiomContentsModel;
import org.infrawebs.axiom.model.AxiomRootModel;
import org.infrawebs.axiom.model.OperatorModel;
import org.infrawebs.axiom.operations.ModelOperations;
import org.infrawebs.axiom.settings.ImageSettings;

public abstract class CreateOperatorAction extends AxiomAction
{
	public CreateOperatorAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		AbstractModel model = this.getSelectedModel();
		return (model instanceof AxiomContentsModel ||
				model instanceof AxiomRootModel);
	}

	protected abstract int getOperatorType();

	@Override
	public void run() {
		if (!calculateEnabled()) {
			return;
		}
		OperatorModel model = getContentsModel().getFactory().createOperator(getOperatorType(), null);
		ModelOperations.createAndConnectToAxiomRoot(model);
	}

	@Override
	protected String getCaption() {
		return "Add operator " + OperatorModel.getOperatorTypeAsString(getOperatorType());
	}

	@Override
	protected Image getImage() {
		return ImageSettings.getImage(ImageSettings.OPERATOR);
	}

}
