package org.infrawebs.axiom.editor.actions.contents;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.editor.actions.ontology.SelectFromOntologyAction;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.AxiomContentsModel;
import org.infrawebs.axiom.model.AxiomRootModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.operations.ModelOperations;
import org.infrawebs.axiom.settings.ImageSettings;
import org.infrawebs.ontology.OntoFilter;
import org.omwg.ontology.OntologyElement;

public class CreateVariableAction extends SelectFromOntologyAction
{
	public CreateVariableAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		AbstractModel model = this.getSelectedModel();
		return (model instanceof AxiomContentsModel ||
				model instanceof AxiomRootModel);
	}
	
	@Override
	protected String getCaption() {
		return "Add a variable";
	}

	@Override
	protected Image getImage() {
		return ImageSettings.getImage(ImageSettings.VARIABLE);
	}

	@Override
	protected String getSelectionDialogTitle() {
		return "Please, select a type for the variable. The type is always a concept.";
	}

	@Override
	protected OntoFilter createOntoFilter() {
		OntoFilter ontoFilter = new OntoFilter(false);
		ontoFilter.showConcepts = true;
		ontoFilter.showAttributes = true;
		ontoFilter.selectConcepts = true;
		return ontoFilter;
	}

	@Override
	protected void onOkPressed(OntologyElement ontologyElement) {
		ModelWithConnections model = getContentsModel().getFactory().createAxiomElement(ontologyElement);
		ModelOperations.createAndConnectToAxiomRoot(model);
	}
}
