package org.infrawebs.axiom.editor.actions.ontology;

import org.infrawebs.axiom.editor.actions.AxiomAction;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.InstanceModel;
import org.infrawebs.axiom.model.RefinableModel;
import org.infrawebs.axiom.plugin.AxiomEditorPlugin;
import org.infrawebs.axiom.settings.ImageSettings;
import org.infrawebs.ontology.shells.RefinableShell;
import org.omwg.ontology.OntologyElement;
import org.omwg.ontology.Type;

public class LocateTypeInOntoViewAction extends AxiomAction
{
	public LocateTypeInOntoViewAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		AbstractModel model = this.getSelectedModel();
		return (model instanceof InstanceModel)
			|| (model instanceof RefinableModel);
	}
	
	@Override
	public void run() {
		if (!calculateEnabled()) {
			return;
		}
		AbstractModel model = this.getSelectedModel();
		OntologyElement element = null;
		if (model instanceof RefinableModel) {
			RefinableShell refinable = ((RefinableModel)model).getRefinable();
			Type type = refinable.getFirstType();
			element = AxiomEditorPlugin.ontoStore.liftTypeToConcept(type); 
		}
		else if (model instanceof InstanceModel) {
			element = ((InstanceModel)model).getConcept();
		}
		
		if (element != null) {
			AxiomEditorPlugin.ontoLoader.jumpToDefinition(element);
		}
	}

	@Override
	protected String getCaption() {
		return "Locate type in Ontology";
	}

	@Override
	protected Image getImage() {
		return ImageSettings.getImage(ImageSettings.LOCATE);
	}

}
