package org.infrawebs.axiom.editor.actions.operators;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.operations.SemanticConsistence;
import org.infrawebs.axiom.settings.ImageSettings;
import org.infrawebs.ontology.OntoFilter;

public class AddOperandCustomTypeVariableAction extends AddOperandCustomTypeAction
{
	public AddOperandCustomTypeVariableAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		// Show action only for refinables of complex types.
		return super.calculateVisible() && !SemanticConsistence.isValueType(this.chainOrigin);
	}

	@Override
	protected String getCaption() {
		return "Add a custom type variable operand...";
	}

	@Override
	protected Image getImage() {
		return ImageSettings.getImage(ImageSettings.VARIABLE);
	}

	@Override
	protected String getSelectionDialogTitle() {
		return "Please, select a type for the variable. The type is always a concept.";
	}

	@Override
	protected OntoFilter createOntoFilter() {
		OntoFilter ontoFilter = super.createOntoFilter();
		ontoFilter.showConcepts = true;
		ontoFilter.showAttributes = true;
		ontoFilter.selectConcepts = true;
		return ontoFilter;
	}
	
}
