package org.infrawebs.axiom.editor.actions.refinables;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.model.RefinableModel;
import org.infrawebs.axiom.operations.SemanticConsistence;
import org.infrawebs.axiom.settings.ImageSettings;

public class RefineByDefaultTypeVariableAction extends RefineByDefaultTypeAction
{
	public RefineByDefaultTypeVariableAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		// Show action only for refinables of complex types.
		return super.calculateVisible() &&
				!SemanticConsistence.isValueType((RefinableModel)getSelectedModel());
	}

	@Override
	protected String getCaption() {
		return "Refine by a default type variable";
	}

	@Override
	protected Image getImage() {
		return ImageSettings.getImage(ImageSettings.VARIABLE);
	}

}
