package org.infrawebs.axiom.editor.actions.visual;

import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IWorkbenchPart;
import org.infrawebs.axiom.editor.actions.AxiomAction;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.model.RefinableModel;

public class BringToFrontAction extends AxiomAction
{
	public BringToFrontAction(IWorkbenchPart part) {
		super(part);
	}

	@Override
	public boolean calculateVisible() {
		AbstractModel model = getSelectedModel();
		return (model instanceof ModelWithConnections)
				&& (!(model instanceof RefinableModel));
	}
	
	@Override
	public void run() {
		if (!calculateEnabled()) {
			return;
		}
		AbstractModel model = this.getSelectedModel();
		getContentsModel().reorderChild((ModelWithConnections)model,
				getContentsModel().getChildren().size() - 1);
	}

	@Override
	protected String getCaption() {
		return "Bring to front";
	}

	@Override
	protected Image getImage() {
		return null;
	}

}
