package org.infrawebs.axiom.editor.editparts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;


import org.eclipse.draw2d.AbsoluteBendpoint;
import org.eclipse.draw2d.BendpointConnectionRouter;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editparts.AbstractConnectionEditPart;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;
import org.infrawebs.axiom.editor.editpolicies.MyConnectionEditPolicy;
import org.infrawebs.axiom.model.ConnectionModel;

public class AxiomConnectionEditPart extends AbstractConnectionEditPart
		implements PropertyChangeListener {

	@Override
	protected IFigure createFigure() {
		PolylineConnection connection = new PolylineConnection();
		
//		Label label = new Label("MP");
//		label.setOpaque(true);
//		label.setBackgroundColor(ColorConstants.buttonLightest);
//		label.setBorder(new LineBorder());
//		connection.add(label, new MidpointLocator(connection, 0));
//
//		ConnectionEndpointLocator targetEndpointLocator = 
//				new ConnectionEndpointLocator(connection, true);
//		targetEndpointLocator.setVDistance(15);
//		Label targetMultiplicityLabel = new Label("dst");
//		connection.add(targetMultiplicityLabel, targetEndpointLocator);
//		ConnectionEndpointLocator sourceEndpointLocator = 
//				new ConnectionEndpointLocator(connection, false);
//		sourceEndpointLocator.setVDistance(15);
//		Label sourceMultiplicityLabel = new Label("scr");
//		connection.add(sourceMultiplicityLabel, sourceEndpointLocator);
//		
//		ConnectionEndpointLocator relationshipLocator = 
//				new ConnectionEndpointLocator(connection, true);
//		relationshipLocator.setUDistance(30);
//		relationshipLocator.setVDistance(-20);
//		Label relationshipLabel = new Label("contains");
//		connection.add(relationshipLabel,relationshipLocator);

		connection.setConnectionRouter(new BendpointConnectionRouter());
		return connection;
	}

	@Override
	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.CONNECTION_ROLE,
			new MyConnectionEditPolicy());

		installEditPolicy(EditPolicy.CONNECTION_ENDPOINTS_ROLE,
			new ConnectionEndpointEditPolicy());
		
	}

	@Override
	public void activate() {
		super.activate();
		((ConnectionModel)getModel()).addPropertyChangeListener(this);
	}

	@Override
	public void deactivate() {
		((ConnectionModel)getModel()).removePropertyChangeListener(this);
		super.deactivate();
	}

	public void propertyChange(PropertyChangeEvent evt) {
		if (evt.getPropertyName().equals(ConnectionModel.ID_PROPERTY_BEND_POINT))
			refreshBendpoints();
	}

	protected void refreshBendpoints() {
		List bendpoints = ((ConnectionModel)getModel()).getBendpoints();
		List<AbsoluteBendpoint> constraint = new ArrayList<AbsoluteBendpoint>();

		for (int i = 0; i < bendpoints.size(); i++) {
			constraint.add(new AbsoluteBendpoint((Point)bendpoints.get(i)));
		}

		getConnectionFigure().setRoutingConstraint(constraint);
	}
	
	@Override
	protected void refreshVisuals() {
		refreshBendpoints();
	}

}
