package org.infrawebs.axiom.editor.editparts;

import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.jface.viewers.TextCellEditor;
import org.infrawebs.axiom.editor.editpolicies.DirectEditWithConnectionsPolicy;

public abstract class DirectEditEditPart extends EditPartWithConnections
{
	private AxiomDirectEditManager directManager = null;

	@Override
	protected void createEditPolicies() {
		super.createEditPolicies();
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new DirectEditWithConnectionsPolicy());
	}

	@Override
	public void performRequest(Request req) {
		if (req.getType().equals(RequestConstants.REQ_DIRECT_EDIT)) {
			if (this.directManager == null) {
				this.directManager =	createDirectEditManager();
			}
			if (this.directManager != null) {
				this.directManager.show();
			}
		}
		else {
			super.performRequest(req);
		}
	}

	protected AxiomDirectEditManager createDirectEditManager() {
		AxiomCellEditorLocator locator = new AxiomCellEditorLocator(getFigure());
		return new AxiomDirectEditManager(this, TextCellEditor.class, locator);
	}
	
	public abstract String getDirectEditText();
	public abstract void setDirectEditText(String text);	
}
