package org.infrawebs.axiom.editor.editparts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.ManhattanConnectionRouter;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.draw2d.geometry.PointList;
import org.infrawebs.axiom.settings.ColorSettings;

public class ManhattanConnectionEditPart extends AxiomConnectionEditPart
{
	@Override
	protected IFigure createFigure() {
		PolylineConnection connection =
			(PolylineConnection) super.createFigure();

//	    PolygonDecoration decSource = new PolygonDecoration();
//	    PointList pointList = new PointList();
//	    pointList.addPoint(0,0);
//	    pointList.addPoint(-2,2);
//	    pointList.addPoint(-4,0);
//	    pointList.addPoint(-2,-2);
//	    decSource.setTemplate(pointList);
//	    decSource.setBackgroundColor(ColorConstants.white);
//	    decSource.setOpaque(true);
//		// decSource.setFill(true);
//		connection.setSourceDecoration(decSource);
	    
		// add a blue dot to indicate the exact attribute where the connection originates
		if (this.getSource() instanceof AttributeEditPart) {
			PolylineDecoration decSource = new PolylineDecoration();
			decSource.setTemplate(new PointList(new int[] {0, 1, 0, -1} ));
			decSource.setLineWidth(7);
			decSource.setForegroundColor(ColorSettings.MEMBEROF_HEADER_BACK);
			decSource.setScale(4, 4);
			connection.setSourceDecoration(decSource);
		} // green - for parameters
		else if (this.getSource() instanceof ParameterEditPart) {
			PolylineDecoration decSource = new PolylineDecoration();
			decSource.setTemplate(new PointList(new int[] {0, 1, 0, -1} ));
			decSource.setLineWidth(7);
			decSource.setForegroundColor(ColorSettings.RELATION_HEADER_BACK);
			decSource.setScale(4, 4);
			connection.setSourceDecoration(decSource);
		}
		
		PolygonDecoration decTarget = new PolygonDecoration();
		decTarget.setScale(10, 3);
		connection.setTargetDecoration(decTarget);
		
		ManhattanConnectionRouter router = new ManhattanConnectionRouter();
		connection.setConnectionRouter(router);
		connection.setLineWidth(2);
		return connection;
	}

}
