package org.infrawebs.axiom.editor.editparts;

import java.beans.PropertyChangeEvent;

import org.eclipse.draw2d.IFigure;
import org.infrawebs.axiom.editor.figures.ValueInstanceFigure;
import org.infrawebs.axiom.model.ValueInstanceModel;
import org.infrawebs.axiom.plugin.AxiomEditorPlugin;

public class ValueInstanceEditPart extends MemberOfEditPart
{
	@Override
	protected IFigure createFigure() {
		ValueInstanceModel model = (ValueInstanceModel)getModel();
		return new ValueInstanceFigure(
				AxiomEditorPlugin.ontoStore.getPrefixedName(model.getConcept()),
				model.getValue(),
				model.getVarNameModel().getExistsFlag(),
				model.isCompact());
	}
	
	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		super.propertyChange(evt);
		
		if (evt.getPropertyName().equals(ValueInstanceModel.ID_PROPERTY_VALUE)) {
			ValueInstanceFigure localFigure = (ValueInstanceFigure)getFigure();
			localFigure.setValue((String)evt.getNewValue());
		}
	}

	@Override
	public String getDirectEditText() {
		ValueInstanceModel model = (ValueInstanceModel)getModel();
		String value = model.getValue();
		return value != null ? value : "";
	}

	@Override
	public void setDirectEditText(String text) {
		ValueInstanceModel model = (ValueInstanceModel)getModel();
		model.setPropertyValue(ValueInstanceModel.ID_PROPERTY_VALUE, text);
	}

}
