package org.infrawebs.axiom.editor.editparts;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.NodeEditPart;
import org.infrawebs.axiom.editor.editpolicies.DeleteVariableEditPolicy;
import org.infrawebs.axiom.editor.figures.VariableFigure;
import org.infrawebs.axiom.model.AttributeListModel;
import org.infrawebs.axiom.model.VarNameHolderModel;
import org.infrawebs.axiom.model.VarNameModel;
import org.infrawebs.axiom.model.VariableModel;
import org.infrawebs.axiom.model.VarNameModel.VarNameException;
import org.infrawebs.axiom.plugin.AxiomEditorPlugin;

// This class is not used for now.
public class VariableEditPart extends MemberOfEditPart implements NodeEditPart
{
	@Override
	public IFigure createFigure() {
		VariableModel model = (VariableModel)getModel();
		return new VariableFigure(
				AxiomEditorPlugin.ontoStore.getPrefixedName(model.getConcept()),
				model.getVarNameModel().getName(),
				model.getVarNameModel().getExistsFlag(),
				model.isCompact());
	}

	@Override
	public List getModelChildren() {
		VariableModel model = (VariableModel)getModel();
		// The only additional child is the attribute list.
		List<AttributeListModel> modelChildren = new ArrayList<AttributeListModel>();
		modelChildren.add(model.getRefinableList());
		return modelChildren;
	}

	@Override
	public void createEditPolicies() {
		super.createEditPolicies();
		// This overrides the component role from EditPartWithConnections.
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new DeleteVariableEditPolicy());
	}

	@Override
	public String getDirectEditText() {
		VarNameHolderModel model = (VarNameHolderModel)getModel();
		return model.getVarNameModel().getName();
	}

	@Override
	public void setDirectEditText(String text) {
		try {
			VarNameHolderModel model = (VarNameHolderModel)getModel();
			model.getVarNameModel().setName(text);
		}
		catch (VarNameException ex) {
			VarNameModel.showWarning(ex);
		}
	}

}
