package org.infrawebs.axiom.editor.editpolicies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.model.VarNameHolderModel;
import org.infrawebs.axiom.model.commands.VarNameChangeCommand;

public class DeleteMemberOfEditPolicy extends DeleteWithConnectionsEditPolicy
{
	@Override
	protected Command createDeleteCommand(ContainerModel container, ModelWithConnections model) {
		CompoundCommand compound = new CompoundCommand();
		compound.add(super.createDeleteCommand(container, model));
		// This will cause the model to detach from its VarNameModel. When the last model
		// detaches itself from a VarNameModel, it in turn excludes itself from its VarNameList.
		compound.add(new VarNameChangeCommand((VarNameHolderModel)model, null));
		return compound;
	}
}
