package org.infrawebs.axiom.editor.editpolicies;

import java.util.Iterator;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.model.RefinableListHolder;
import org.infrawebs.axiom.model.RefinableListModel;
import org.infrawebs.axiom.model.RefinableModel;
import org.infrawebs.axiom.model.commands.ContainerDeleteWithConnectionsCommand;
import org.infrawebs.axiom.model.commands.VarNameChangeCommand;

public class DeleteRelationEditPolicy extends DeleteWithConnectionsEditPolicy
{
	// Adds commands which delete all refinables contained in a variable or a relation.
	public static void addDeleteRefinebleCommands(RefinableListHolder holder, CompoundCommand compound) {
		RefinableListModel list = holder.getRefinableList();
		Iterator iter = list.getChildren().iterator();
		while (iter.hasNext()) {
			RefinableModel refinable = (RefinableModel)iter.next();
			compound.add(new ContainerDeleteWithConnectionsCommand(list, refinable));
			// This will cause the refinable to detach from its VarNameModel. When the last model
			// detaches itself from a VarNameModel, it in turn excludes itself from its VarNameList.
			compound.add(new VarNameChangeCommand(refinable, null));
		}
	}

	@Override
	protected Command createDeleteCommand(ContainerModel container, ModelWithConnections model) {
		CompoundCommand compound = new CompoundCommand();
		addDeleteRefinebleCommands((RefinableListHolder)getHost().getModel(), compound);
		compound.add(super.createDeleteCommand(container, model));
		return compound;
	}
}
