package org.infrawebs.axiom.editor.editpolicies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.model.commands.ContainerDeleteWithConnectionsCommand;

public class DeleteWithConnectionsEditPolicy extends ComponentEditPolicy
{
	@Override
	protected Command createDeleteCommand(GroupRequest deleteRequest) {
		AbstractModel parentModel = (AbstractModel)getHost().getParent().getModel();
		if (!(parentModel instanceof ContainerModel)) {
			return null;
		}

		ContainerModel container = (ContainerModel)parentModel;
		ModelWithConnections model = (ModelWithConnections)getHost().getModel();
		// Avoid creating delete commands for already deleted models.
		return container.getChildren().contains(model)
				? createDeleteCommand(container, model) : null;
	}

	protected Command createDeleteCommand(ContainerModel container, ModelWithConnections model) {
		return new ContainerDeleteWithConnectionsCommand(container, model);
	}
}
