package org.infrawebs.axiom.editor.editpolicies;


import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.BendpointEditPolicy;
import org.eclipse.gef.requests.BendpointRequest;
import org.infrawebs.axiom.model.commands.BendpointCreateCommand;
import org.infrawebs.axiom.model.commands.BendpointDeleteCommand;
import org.infrawebs.axiom.model.commands.BendpointMoveCommand;

public class MyBendpointEditPolicy extends BendpointEditPolicy
{
	@Override
	protected Command getCreateBendpointCommand(BendpointRequest request) {
		Point point = request.getLocation();
		getConnection().translateToRelative(point);

		BendpointCreateCommand command = new BendpointCreateCommand();
		command.setLocation(point);
		command.setConnection(getHost().getModel());
		command.setIndex(request.getIndex());

		return command;
	}

	@Override
	protected Command getDeleteBendpointCommand(BendpointRequest request) {
		BendpointDeleteCommand command = new BendpointDeleteCommand();
		command.setConnectionModel(getHost().getModel());
		command.setIndex(request.getIndex());
		return command;
	}

	@Override
	protected Command getMoveBendpointCommand(BendpointRequest request) {
		Point location = request.getLocation();
		getConnection().translateToRelative(location);

		BendpointMoveCommand command = new BendpointMoveCommand();
		command.setConnectionModel(getHost().getModel());
		command.setIndex(request.getIndex());
		command.setNewLocation(location);

		return command;
	}

}
