package org.infrawebs.axiom.editor.editpolicies;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.infrawebs.axiom.model.AbstractModel;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.model.commands.ChangeConstraintCommand;
import org.infrawebs.axiom.model.commands.ContainerAddChildCommand;

public class RootLayoutEditPolicy extends XYLayoutEditPolicy
{
	@Override
	protected Command createAddCommand(EditPart child, Object constraint) {
		return null;
	}

	@Override
	protected Command createChangeConstraintCommand(EditPart child,	Object constraint) {
		ChangeConstraintCommand command = new ChangeConstraintCommand();
		AbstractModel model = (AbstractModel)child.getModel();
		command.setModel(model);
		command.setConstraint(constraint);
		return command;
	}

	@Override
	protected Command getCreateCommand(CreateRequest request) {
		Object constraint = getConstraintFor(request);
		ModelWithConnections model = (ModelWithConnections)request.getNewObject();
		if (model != null) {
			model.setConstraint(constraint);
			ContainerModel container = (ContainerModel)getHost().getModel();
			return new ContainerAddChildCommand(container, model);
		}
		return null;
	}

	@Override
	protected Command getDeleteDependantCommand(Request request) {
		return null;
	}

}
