package org.infrawebs.axiom.editor.editpolicies;

import java.util.Iterator;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gef.requests.GroupRequest;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;
import org.infrawebs.axiom.model.commands.ContainerAddChildCommand;
import org.infrawebs.axiom.model.commands.ContainerDeleteWithConnectionsCommand;
import org.infrawebs.axiom.model.commands.ContainerMoveChildCommand;

public class ToolbarLayoutEditPolicyImpl extends ToolbarLayoutEditPolicy
{
	@Override
	protected Command getCreateCommand(CreateRequest request) {
		ModelWithConnections newAttribute = (ModelWithConnections)request.getNewObject();
		ContainerModel list = (ContainerModel)getHost().getModel();
		return new ContainerAddChildCommand(list, newAttribute);
	}

	// Tova e neobhodimo, ako trjabva da se mestjat children-i ot 1 container v drug s drag&drop
	@Override
	protected Command createAddCommand(EditPart child, EditPart after) {
//		if (getHost() instanceof AttributeListEditPart
//			&& child instanceof AttributeEditPart) {
//			AbstractModel childModel = (AbstractModel)child.getModel();
//			AbstractModel afterModel = (after == null) ? null : (AbstractModel)after.getModel();
//			ContainerModel list = (ContainerModel) getHost().getModel();
//			return new ContainerAddChildCommand(list, childModel, afterModel);
//		}
//		else
			return null;
	}
	
	// Tova e neobhodimo, ako trjabva da se mestjat children-i ot 1 container v drug s drag&drop
//	protected Command getOrphanChildrenCommand(Request request) {
//		CompoundCommand cc = new CompoundCommand();
//		ContainerModel list = (ContainerModel) getHost().getModel();
//		Iterator it = ((GroupRequest) request).getEditParts().iterator();
//		while (it.hasNext()) {
//			cc.add(new ContainerDeleteChildCommand(list,
//					(AbstractModel)((EditPart) it.next()).getModel()));
//		}
//		return cc;
//	}
	
	@Override
	protected Command createMoveChildCommand(EditPart child, EditPart after) {
		ContainerModel list = (ContainerModel)getHost().getModel();
		ModelWithConnections childModel = (ModelWithConnections)child.getModel();
		ModelWithConnections afterModel = (after == null) ? null : (ModelWithConnections)after.getModel();
		return new ContainerMoveChildCommand(list, childModel, afterModel);
	}

	@Override
	protected Command getDeleteDependantCommand(Request request) {
		CompoundCommand cc = new CompoundCommand();
		ContainerModel list = (ContainerModel) getHost().getModel();
		Iterator it = ((GroupRequest) request).getEditParts().iterator();
		while (it.hasNext()) {
			ModelWithConnections model = (ModelWithConnections) ((EditPart) it.next()).getModel();
			cc.add(new ContainerDeleteWithConnectionsCommand(list, model));
		}
		return cc;
	}

}
