package org.infrawebs.axiom.editor.figures;

import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.swt.graphics.Color;
import org.eclipse.draw2d.geometry.*;

public class ListFigureBorder extends AbstractLabeledBorder
{
	private Color color;
	private static final int BORDER_SIZE = 2;//voir calculateInsets pour comprendre ce que c'est
	private static final int DECALAGE_LABEL = 5;
	private static final int MARGIN_SIZE = 5;
	
	public void paint(IFigure f, Graphics g, Insets insetsFigure) {
		Rectangle area = f.getBounds().getCropped(insetsFigure);
		g.clipRect(area);
		
		//ligne:
		if (this.color != null) {
			g.setForegroundColor(this.color);
		}
		Point gauche = area.getLocation().translate(0,(getInsets(f).top-BORDER_SIZE)/2);
		Point droit = gauche.getCopy().translate(area.width,0);
		g.drawLine(gauche, droit);
		
		//marge:
		Color background = g.getBackgroundColor();
		if (this.color != null) {
			g.setBackgroundColor(this.color);
		}
		g.fillRectangle(area.x, droit.y, MARGIN_SIZE, area.height-(droit.y-area.y));
		g.setBackgroundColor(background);
		
		//label:
		Point coinSupGaucheText = area.getLocation().translate(DECALAGE_LABEL + MARGIN_SIZE,0);
		g.fillString(getLabel(), coinSupGaucheText);
	}
	
	public void setColor (Color c) {
		this.color = c;
	}

	@Override
	public Insets calculateInsets(IFigure f) {
		Dimension textSize = FigureUtilities.getTextExtents(getLabel(), getFont(f));
		int top = textSize.height + BORDER_SIZE;
		int left = MARGIN_SIZE + BORDER_SIZE;
		return new Insets(top, left, BORDER_SIZE, BORDER_SIZE);
	}
}
