package org.infrawebs.axiom.editor.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.swt.graphics.Color;

class PartialBorder extends LineBorder
{
	private Insets borderWidths = null;
	
	public PartialBorder(Color color, Insets borderWidths) {
		super(color);
		this.borderWidths = borderWidths;
	}

	@Override
	public Insets getInsets(IFigure figure) {
    	return new Insets((this.borderWidths.top + 1) / 2, 
    			(this.borderWidths.left + 1) / 2,
    			(this.borderWidths.bottom + 1) / 2,
    			(this.borderWidths.right + 1) / 2);
	}

	@Override
	public void paint(IFigure figure, Graphics graphics, Insets insets) {
		tempRect.setBounds(getPaintRectangle(figure, insets));
		if (getWidth() % 2 == 1) {
			tempRect.width--;
			tempRect.height--;
		}
		tempRect.shrink(getWidth() / 2, getWidth() / 2);
		graphics.setLineWidth(getWidth());
		if (getColor() != null)
			graphics.setForegroundColor(getColor());
//		graphics.drawRectangle(tempRect);
//		graphics.setLineStyle(graphics.LINE_DOT);
		if (this.borderWidths.top > 0) {
			graphics.setLineWidth(this.borderWidths.top);
			graphics.drawLine(tempRect.getTopLeft(), tempRect.getTopRight());
		}
		if (this.borderWidths.left > 0) {
			graphics.setLineWidth(this.borderWidths.left);
			graphics.drawLine(tempRect.getTopLeft(), tempRect.getBottomLeft());
		}
		if (this.borderWidths.bottom > 0) {
			graphics.setLineWidth(this.borderWidths.bottom);
			graphics.drawLine(tempRect.getBottomLeft(), tempRect.getBottomRight());
		}
		if (this.borderWidths.right > 0) {
			graphics.setLineWidth(this.borderWidths.right);
			graphics.drawLine(tempRect.getTopRight(), tempRect.getBottomRight());
		}
		
	}	
}