package org.infrawebs.axiom.editor.figures;

import org.eclipse.draw2d.AbstractConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;

public class RatioConnectionAnchor extends AbstractConnectionAnchor {

	private double ratioX;
	private double ratioY;	

  public RatioConnectionAnchor(IFigure iOwner, double ratioX, double ratioY)
  {
  	super(iOwner);
  	this.ratioX = ratioX;
  	this.ratioY = ratioY;
  }

  public Point getLocation(Point reference) {
  	
  	Rectangle rect = Rectangle.SINGLETON;
	rect.setBounds(getOwner().getBounds());
	getOwner().translateToAbsolute(rect);
	
  	double x = rect.x + rect.width * this.ratioX;
  	double y = rect.y + rect.height * this.ratioY;
  	return new Point(x, y);
  }
  
}
