package org.infrawebs.axiom.model;

import java.util.ArrayList;
import java.util.List;

public class AttributeListModel extends RefinableListModel
{
	private static final long serialVersionUID = 200510291900L;
	
	public AttributeListModel(VariableModel owner) {
		super(owner);
	}

	public List<AttributeModel> listRefinedAttributes() {
		List<AttributeModel> result = new ArrayList<AttributeModel>();
		for (ModelWithConnections child: getChildren()) {
			AttributeModel attrModel = (AttributeModel)child; 
			if (attrModel.getRefiningModel() != null) {
				result.add(attrModel);
			}
		}
		return result;
	}
	
	// An attribute may be refined by exactly 1 subexpression.
	@Override
	public List<ModelWithConnections> listRefiningModels() {
		List<ModelWithConnections> result = new ArrayList<ModelWithConnections>();
		for (ModelWithConnections child: getChildren()) {
			AttributeModel attrModel = (AttributeModel)child; 
			ModelWithConnections refinementModel = attrModel.getRefiningModel();
			// Skip attributes which are not refined.
			if (refinementModel != null) {
				result.add(refinementModel);
			}
		}
		return result;
	}
}
