package org.infrawebs.axiom.model;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.omwg.ontology.Concept;

public class ValueInstanceModel extends MemberOfModel
{
	private static final long serialVersionUID = 200512242100L;

	public static final String ID_PROPERTY_VALUE = "ID_PROPERTY_VALUE";

	private String value = null;

	public ValueInstanceModel(AxiomContentsModel contents, Concept parent) {
		super(contents, parent);
	}

	public String getValue() {
		return this.value;
	}

	public void setValue(String text) {
		this.value = text;
		firePropertyChange(ID_PROPERTY_VALUE, null, text);
	}

	@Override
	public IPropertyDescriptor[] createPropertyDescriptors() {
		IPropertyDescriptor[] superDescriptors = super.createPropertyDescriptors();
		int oldLen = superDescriptors.length;
		IPropertyDescriptor[] descriptors = new IPropertyDescriptor[oldLen + 1];
		System.arraycopy(superDescriptors, 0, descriptors, 0, oldLen);
		descriptors[oldLen + 0] = new TextPropertyDescriptor(ID_PROPERTY_VALUE, "Value");
		return descriptors;
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id.equals(ID_PROPERTY_VALUE)) {
			return (this.value == null) ? "" : this.value;
		}
		return super.getPropertyValue(id);
	}


	@Override
	public void setPropertyValue(Object id, Object value) {
		if (id.equals(ID_PROPERTY_VALUE)) {
			String strVal = (String)value;
			// Treat the empty string as an attempt to delete the value.
			// Assign null instead of the empty string.
			setValue((strVal != null && strVal.length() > 0) ? strVal : null);
		} 
		else super.setPropertyValue(id, value);
	}

}
