package org.infrawebs.axiom.model;

import java.util.Iterator;
import org.infrawebs.ontology.shells.AttributeShell;
import org.infrawebs.ontology.shells.OntologyShell;
import org.omwg.ontology.Concept;

public class VariableModel extends MemberOfModel implements RefinableListHolder
{
	private static final long serialVersionUID = 200512242100L;

	private AttributeListModel attributeList = new AttributeListModel(this);
	
	public VariableModel(AxiomContentsModel contents, Concept concept) {
		super(contents, concept);
		
		// Add the concept's attributeList.
		Iterator i = OntologyShell.listAttributesRecursive(concept).iterator();
		while (i.hasNext()) {
			AttributeShell attrInfo = (AttributeShell)i.next();
			AttributeModel attr = new AttributeModel(this.contents, attrInfo);
			this.attributeList.addChild(attr);
		}
	}
	
	public AttributeListModel getRefinableList() {
		return this.attributeList;
	}

}
