package org.infrawebs.axiom.model.commands;


import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.model.AbstractModel;

public class ChangeConstraintCommand extends Command {
	private AbstractModel model;
	private Object constraint;
	private Object oldConstraint;

	@Override
	public void execute() {
		this.model.setConstraint(this.constraint);
	}

	public void setConstraint(Object constraint) {
		this.constraint = constraint;
	}

	public void setModel(AbstractModel model) {
		this.model = model;
		this.oldConstraint = model.getConstraint();
	}

	@Override
	public void undo() {
		this.model.setConstraint(this.oldConstraint);
	}

}
