package org.infrawebs.axiom.model.commands;

import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.model.ContainerModel;
import org.infrawebs.axiom.model.ModelWithConnections;

public class ContainerAddChildCommand extends Command {
	private ContainerModel container = null;
	private ModelWithConnections model = null;
	private ModelWithConnections after = null;
	
	public ContainerAddChildCommand(ContainerModel container, ModelWithConnections model) {
		this.container = container;
		this.model = model;
	}

	public ContainerAddChildCommand(ContainerModel container, ModelWithConnections model,
			ModelWithConnections after) {
		this(container, model);
		this.after = after;
	}
	
	@Override
	public void execute() {
		if (this.after == null)
			this.container.addChild(this.model);
		else
		{
			int indexAfter = this.container.getChildren().indexOf(this.after);
			this.container.addChild(indexAfter + 1, this.model);
		}
	}

	@Override
	public void undo() {
		this.container.removeChild(this.model);
	}
}
