package org.infrawebs.axiom.model.commands;


import org.eclipse.gef.commands.Command;
import org.infrawebs.axiom.editor.editparts.DirectEditEditPart;

public class DirectEditCommand extends Command {
	private String oldText, newText;
	private DirectEditEditPart editPart;

	public DirectEditCommand(DirectEditEditPart editPart, String newText) {
		this.editPart = editPart;
		this.newText = newText;
	}
	
	@Override
	public void execute() {
		this.oldText = this.editPart.getDirectEditText();
		this.editPart.setDirectEditText(this.newText);
	}

	@Override
	public void undo() {
		this.editPart.setDirectEditText(this.oldText);
	}

}
