package org.infrawebs.axiom.outline.editparts;

import org.infrawebs.axiom.model.ParameterModel;
import org.infrawebs.axiom.model.VarNameModel;
import org.infrawebs.common.Util;
import org.infrawebs.ontology.ui.OntoImages;

public class ParameterTreeEditPart extends TreeEditPartWithConnections
{
	@Override
	protected void refreshVisuals() {
		// Display all parameters.
		ParameterModel parameter = (ParameterModel)getModel();
		VarNameModel varNameModel = parameter.getVarNameModel();
		if (parameter.getRefiningModel() != null) {
			// Display the variable name of connected parameters.
			setWidgetText(varNameModel.getName());
			setWidgetImage(OntoImages.getImage(OntoImages.RELATION_PARAMETER));
		}
		else {
			// Display the type of disconnected parameters.
			setWidgetText(Util.getLocalName(parameter.getRefinable().getFirstType()));
			setWidgetImage(OntoImages.getImage(OntoImages.RELATION_PARAMETER_DISABLED));
		}
	}
}
