package org.infrawebs.axiom.plugin;

import org.eclipse.draw2d.PositionConstants;
import org.eclipse.gef.ui.actions.ActionBarContributor;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.gef.ui.actions.AlignmentRetargetAction;
import org.eclipse.gef.ui.actions.DeleteRetargetAction;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.gef.ui.actions.RedoRetargetAction;
import org.eclipse.gef.ui.actions.UndoRetargetAction;
import org.eclipse.gef.ui.actions.ZoomComboContributionItem;
import org.eclipse.gef.ui.actions.ZoomInRetargetAction;
import org.eclipse.gef.ui.actions.ZoomOutRetargetAction;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.ui.actions.ActionFactory;

public class Contributor extends ActionBarContributor
{
	@Override
	protected void buildActions() {
		addRetargetAction(new UndoRetargetAction());
		addRetargetAction(new RedoRetargetAction());
		addRetargetAction(new DeleteRetargetAction());
		addRetargetAction(new ZoomInRetargetAction());
		addRetargetAction(new ZoomOutRetargetAction());
	
		addRetargetAction(new AlignmentRetargetAction(PositionConstants.LEFT));
		addRetargetAction(new AlignmentRetargetAction(PositionConstants.CENTER));
		addRetargetAction(new AlignmentRetargetAction(PositionConstants.RIGHT));
		addRetargetAction(new AlignmentRetargetAction(PositionConstants.TOP));
		addRetargetAction(new AlignmentRetargetAction(PositionConstants.MIDDLE));
		addRetargetAction(new AlignmentRetargetAction(PositionConstants.BOTTOM));
	}

	@Override
	protected void declareGlobalActionKeys() {
		// Nothing to declare.
	}

	@Override
	public void contributeToToolBar(IToolBarManager toolBarManager) {
		ActionRegistry reg = getActionRegistry();
		toolBarManager.add(reg.getAction(ActionFactory.DELETE.getId()));
		toolBarManager.add(reg.getAction(ActionFactory.UNDO.getId()));
		toolBarManager.add(reg.getAction(ActionFactory.REDO.getId()));
		toolBarManager.add(new Separator());
		toolBarManager.add(reg.getAction(GEFActionConstants.ALIGN_LEFT));
		toolBarManager.add(reg.getAction(GEFActionConstants.ALIGN_CENTER));
		toolBarManager.add(reg.getAction(GEFActionConstants.ALIGN_RIGHT));
		toolBarManager.add(new Separator());
		toolBarManager.add(reg.getAction(GEFActionConstants.ALIGN_TOP));
		toolBarManager.add(reg.getAction(GEFActionConstants.ALIGN_MIDDLE));
		toolBarManager.add(reg.getAction(GEFActionConstants.ALIGN_BOTTOM));
		toolBarManager.add(new Separator());
		toolBarManager.add(reg.getAction(GEFActionConstants.ZOOM_IN));
		toolBarManager.add(reg.getAction(GEFActionConstants.ZOOM_OUT));
		toolBarManager.add(new ZoomComboContributionItem(getPage()));
	}
}
