package org.infrawebs.axiom.plugin;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.infrawebs.axiom.text.AxiomTextView;

public class Perspective implements IPerspectiveFactory
{
	public static final String PERSPECTIVE_ID = "org.infrawebs.axiom.plugin.perspective"; 

	public void createInitialLayout(IPageLayout layout) {
		defineActions(layout);
		defineLayout(layout);

//		TODO: UN-successful try to set COOL Tab-style...
//		IPreferenceStore store = Workbench.getInstance().getPreferenceStore();
//		store.setValue(IWorkbenchPreferenceConstants.SHOW_TRADITIONAL_STYLE_TABS, false);
//		store.setDefault(IWorkbenchPreferenceConstants.SHOW_TRADITIONAL_STYLE_TABS, false);
	}

	public void defineActions(IPageLayout layout) {
		layout.addShowViewShortcut(IPageLayout.ID_RES_NAV);
		layout.addShowViewShortcut(IPageLayout.ID_BOOKMARKS);
		layout.addShowViewShortcut(IPageLayout.ID_OUTLINE);
		layout.addShowViewShortcut(IPageLayout.ID_PROP_SHEET);
		layout.addShowViewShortcut(IPageLayout.ID_PROBLEM_VIEW);
		layout.addShowViewShortcut(IPageLayout.ID_TASK_LIST);
		
		layout.addActionSet(IPageLayout.ID_NAVIGATE_ACTION_SET);

		layout.addPerspectiveShortcut(PERSPECTIVE_ID);
		layout.addShowViewShortcut(AxiomOntoView.VIEW_ID);
	}

    public void defineLayout(IPageLayout layout) {
        // Editors are placed for free.
        String editorArea = layout.getEditorArea();

        IFolderLayout naviFolder = layout.createFolder("naviFolder", IPageLayout.LEFT, 0.25f, editorArea);
        naviFolder.addView(AxiomOntoView.VIEW_ID);
        naviFolder.addView(IPageLayout.ID_RES_NAV);

        IFolderLayout outlineFolder = layout.createFolder("outlineFolder", IPageLayout.BOTTOM, 0.6f, "naviFolder");
        outlineFolder.addView("org.wsmostudio.ui.views.WSMOView");


        IFolderLayout propsFolder = layout.createFolder("propsFolder", IPageLayout.BOTTOM, 0.75f, editorArea);
        propsFolder.addView(AxiomTextView.VIEW_ID);
        propsFolder.addView(IPageLayout.ID_PROP_SHEET);
        propsFolder.addView(IPageLayout.ID_PROBLEM_VIEW);

        IFolderLayout bottomRight = layout.createFolder("bottomRight",//$NON-NLS-1$
                IPageLayout.RIGHT, (float)0.5, "propsFolder");//$NON-NLS-1$
        bottomRight.addView(IPageLayout.ID_OUTLINE);
    }
    
}
