package org.infrawebs.axiom.plugin.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PartInitException;
import org.infrawebs.axiom.editor.AxiomEditor;
import org.infrawebs.axiom.editor.inputs.NewEditorInput;

public class NewAction extends Action implements IWorkbenchWindowActionDelegate
{
	private IWorkbenchWindow window;

	public void init(IWorkbenchWindow workbenchWindow) {
		this.window = workbenchWindow;
	}

	public void dispose() {
		this.window = null;
	}

	public void selectionChanged(IAction action, ISelection selection) {
		// Obligation to implement.
	}

	public void run(IAction action) {
		IWorkbenchPage page = this.window.getActivePage();
		IEditorInput input = new NewEditorInput();
		try {
			// Create or focus an appropriate editor for the input specified.
			page.openEditor(input, AxiomEditor.EDITOR_ID);
		}
		catch (PartInitException e) {
			e.printStackTrace();
		}
	}

}
