package org.infrawebs.axiom.settings;

import org.eclipse.swt.graphics.Image;

public class ImageSettings
{
	public static final int VARIABLE = 0;
	public static final int OPERATOR = 1;
	public static final int CONNECTION = 2;
	public static final int VARIABLE_EXISTS = 3;
	public static final int LOCATE = 4;
	public static final int ICON_16 = 5;
	public static final int ICON_32 = 6;
	
	// NOTE: Update this image count accordingly.
	private static final int IMAGE_COUNT = 7;
	
	private static String[] fileNames = new String[IMAGE_COUNT];
	private static Image[] images = new Image[IMAGE_COUNT];
	
	static {
		fileNames[VARIABLE] = "Variable.gif";
		fileNames[OPERATOR] = "Operator.gif";
		fileNames[CONNECTION] = "Connection.gif";
		fileNames[VARIABLE_EXISTS] = "VariableExists.gif";
		fileNames[LOCATE] = "Locate.gif";
		fileNames[ICON_16] = "Icon16.gif";
		fileNames[ICON_32] = "Icon32.gif";

		for (int i = 0; i < IMAGE_COUNT; i++) {
			try {
				String fileName = "icons/" + fileNames[i];
				images[i] = new Image(null, ImageSettings.class.getResourceAsStream(fileName));
			}
			catch (Exception ex) {
				// TODO: Use default images.
			}
		}
	}
	
	public static Image getImage(int index) {
		return (index >= 0) && (index < IMAGE_COUNT) ?
				images[index] : null;
	}
	
}
