package org.infrawebs.axiom.text.editparts;

import org.eclipse.gef.DragTracker;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.Request;
import org.eclipse.gef.RootEditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.UnexecutableCommand;
import org.eclipse.gef.editparts.AbstractEditPart;
import org.eclipse.swt.widgets.Text;

/**
 * @see org.eclipse.gef.editparts.RootTreeEditPart
 */
public class AxiomTextRootEditPart extends AbstractEditPart implements RootEditPart
{
	private EditPartViewer viewer;
	private EditPart contents;

	@Override
	public Command getCommand(Request request) {
		return UnexecutableCommand.INSTANCE;
	}

	/**
	 * By default EditParts return their parent's RootEditPart.
	 * This delegation ends here because RootEditParts return themselves.
	 */
	@Override
	public RootEditPart getRoot() {
		return this;
	}

	/**
	 * By default EditParts return their root's viewer.
	 * This delegation ends here because RootEditParts return the actual viewer.
	 */
	@Override
	public EditPartViewer getViewer() {
		return this.viewer;
	}

	public void setViewer(EditPartViewer viewer) {
		this.viewer = viewer;
	}

	public DragTracker getDragTracker(Request request) {
		return null;
	}

	@Override
	protected void createEditPolicies() {
		// No edit policies to craate.
	}

	@Override
	protected void addChildVisual(EditPart childEditPart, int index) {
		// Obligation to implement.
	}

	@Override
	protected void removeChildVisual(EditPart childEditPart) { 
		// Obligation to implement.
	}

	public EditPart getContents() {
		return this.contents;
	}

	public void setContents(EditPart editpart) {
		if (this.contents != null) {
			if (this.viewer != null && this.viewer.getControl() != null) {
				((Text)this.viewer.getControl()).setText("");
			}
			removeChild(this.contents);
		}
		this.contents = editpart;

		if (this.contents != null) {
			addChild(this.contents, -1);
		}
	}

}
