package org.infrawebs.ontology;

import java.io.IOException;

/**
 * Thrown when a required ontology element was not found or didn't have the expected structure.
 * Such errors occur during the on-demand loading of required ontologies.
 * IOException is extended because this exception could be thrown during deserialization
 * of objects which require ontologies to be loaded.
 */
public class RestorationException extends IOException
{
	private static final long serialVersionUID = 200512270000L;

    public RestorationException(String message) {
    	super(message);
    }
}
