package org.infrawebs.ontology.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.infrawebs.ontology.ui.OntoImages;
import org.infrawebs.ontology.ui.OntoView;

public class OpenOntologyAction extends Action
{
	private OntoView owner = null;
	
	public OpenOntologyAction(OntoView owner) {
		super();
		this.owner = owner;
		setId(this.getClass().getName());
		setText("Open ontology");
		setImageDescriptor(ImageDescriptor.createFromImage(OntoImages.getImage(OntoImages.OPEN_FILE)));
		setToolTipText("Loads ontologies stored in a wsml file.");
	}

	@Override
	public void run() {
		FileDialog dialog = new FileDialog(this.owner.getSite().getShell(), SWT.OPEN);
		dialog.setText("Open ontology..."); //$NON-NLS-1$
		dialog.setFilterNames(new String[] {
				"Ontologies (*.wsml)",
				"All files (*.*)"
		});
		dialog.setFilterExtensions(new String[] {
				"*.wsml", //$NON-NLS-1$
				"*.*" //$NON-NLS-1$
		});
		String path = dialog.open();
		if (path != null && path.length() > 0) {
			this.owner.getOntoLoader().loadOntologiesFromFile(path, false);
		}
	}

}
