;;; -*- Mode:Lisp; Base:10; Package: http -*-

;;; File: pages.lisp
;;; Program: 

;;; Author: Alberto Riva (alb@ipvaim.unipv.it)
;;; Created: Wed May 17, 1995
;;; Updated: Mon Oct 23, 1995


                                                                                ;Starting column for comments
;;; Contents:

;;; -*- -*-

(in-package :lispweb-user)

;;; System pages
;;; These pages are hard-wired in the server.

(defconstant *copyright*
    (concatenate 'string 
      "<HR><H5>&copy; 1995 " (anchor "http://aim.unipv.it/lab/curriculum/Riva.html"
				     "Alberto Riva")
      ", " (anchor "http://aim.unipv.it/" "Medical Informatics Laboratory")
      ", University of Pavia</H5>" ))

(defun lispweb-logo ()
  (html-out (client-side-map "logo"
	      (html-out (area '( 80  30 174 65) 
			      :href (url 'logo-page :full t :args '(lispweb))
			      :onmouseover "set_status('Describe the LispWeb server.'); return true;"))
	      (html-out (area '(175  30 230 65) 
			      :href (url 'logo-page :full t :args '(http))
			      :onmouseover "set_status('Describe the HTTP protocol.'); return true;"))
	      (html-out (area '(230  30 300 65) 
			      :href (url 'logo-page :full t :args '(server))
			      :onmouseover "set_status('Describe what an HTTP server is.'); return true;"))
	      (html-out (area '(   0   0 382 96) 
			      :href (url 'logo-page :full t :args '(default))
			      :onmouseover "set_status('Please click on one of the words.'); return true;"))))
  (html-out (center (image-map (url 'logo-page :full t) 
			       "/image/logo.gif" 
			       :usemap "#logo"))))

(define-page ("Common Lisp Http Server Top Page" :func-name top-page 
						 :url "/top" 
						 :class :system
						 :javascript *js-set-status* 
						 :visible t)
    ()
  (lispweb-logo)
  (html-out (center (header 2 (format nil "Version ~a~%" *LispWeb-version*))))
  (html-out "<HR>~%")
  (html-out (header 4 (html-build "The server you are using is written in Common Lisp 
and runs on a Sun SparcStation 10 in the ~a of the University of Pavia, Italy.~%"
				  (anchor "http://aim.unipv.it/" "Medical Informatics Laboratory"))))
  (html-out "<HR>~%")
  (html-out (header 4 "Server configuration and usage:"))
  (html-out (dotted-list (list (page-anchor 'lispweb-doc "On-line documentation" :full t)
			       (page-anchor 'status-page "See the status of the server")
			       (page-anchor 'comment-page "Send us your comments on this server"))))
  (when *top-level-links*
    (html-out "<HR>~%")
    (html-out (bold (html-build "This server hosts the following ~a:~%" (page-anchor 'wba "web-based applications"))))
    (html-out (dotted-list (reverse *top-level-links*))))
  (when *stsp-tasks*
    (html-out "<HR>~%")
    (html-out (bold (html-build "LispWeb also acts as an ~a. Here is a list of the tasks it supports:~%" (page-anchor 'stsp "STSP Task Server"))))
    (html-out (dotted-list (reverse (mapcar #'(lambda (task)
						(page-anchor 'stsp::task-info
							     (format nil "~(~a~)" (task-name task))
							     :args (list (task-name task))))
					    *stsp-tasks*)))))
  (html-out *copyright*))

(define-no-page (:func-name logo-map :class :system)
    (&key map-x map-y)
  (region-cond map-x map-y
	       ((:rect 80 30 174 65) 
		(logo-page :lispweb map-x map-y))
	       ((:rect 230 30 300 65)
		(logo-page :server map-x map-y))
	       ((:rect 175 30 230 65)
		(logo-page :http map-x map-y))
	       ((:default) 
		(logo-page :default map-x map-y)))
  (html-out "<HR>Go back to the ~a.~%" (anchor "/" "Top Page")))

(define-page ("The LispWeb Logo" :func-name logo-page 
				 :class :system
				 :javascript *js-set-status*)
    (where &optional (map-x 10) (map-y 10))
  (setq where (intern where :keyword))
  (lispweb-logo)
  (case where
    (:lispweb (html-out "<P>LispWeb is an HTTP server written in Common Lisp. It allows you to use the World-Wide Web to deliver
your Lisp applications to the outside world, exploiting the graphical and navigational capabilities of a standard Web-browser."))
    (:server (html-out "<P>A Server is any program able to open network sockets, listen for incoming connections and reply
to the requests supplied by client programs. On the World-Wibe Web, requests are usually expressed using the HTTP
protocol and replies are in the form of HTML pages."))
    (:http (html-out "<P>HTTP is the standard protocol used by clients and servers to communicate over the World-Wide Web.
HTTP requests can use one of several methods, of which GET and POST are the most widely used. The LispWeb server
also understands the STSP method, an extension to HTTP for server-to-server communication."))
    (:default (html-out "<P>Please click on one of the words to get information about the corresponding subject.")))
  (html-out "<HR>Go back to the ~a." (anchor "/" "Top Page")))
	
#|
(define-gd (:func-name logo-image :class :system)
    (x y)
  (let* ((map-x (parse-integer x))
	 (map-y (parse-integer y))
	 (touch-logo (gd-image-create-from-gif (lispweb-path "logo.gif")))
	 (white (gd-image-color-allocate touch-logo 250 250 250))
	 (black (gd-image-color-allocate touch-logo 0 0 0)))
    (gd-image-line touch-logo (- map-x 10) (+ map-y 10) (+ map-x 10) (- map-y 10) black)
    (gd-image-line touch-logo (- map-x 10) (- map-y 10) (+ map-x 10) (+ map-y 10) black)
    (region-cond map-x map-y
		 ((:rect 80 30 174 65) 
		  (gd-image-rectangle touch-logo 80 30 174 65 white))
		 ((:rect 230 30 300 65)
		  (gd-image-rectangle touch-logo 230 30 300 65 white))
		 ((:rect 175 30 230 65)
		  (gd-image-rectangle touch-logo 175 30 230 65 white)))
    touch-logo))
|#

(define-page ("Web-Based Applications" :func-name wba :class :system)
    ()
  (html-out *LispWeb-banner*)
  (html-out "<P>A ~a is a set of ~a page definitions that represents an HTML interface to an underlying Lisp application.~%"
	    (bold "Web-Based Application")
	    (page-anchor 'hall "HALL" :full t)))
  
(define-page ("The STSP Protocol" :func-name stsp :class :system)
    ()
  (html-out *LispWeb-banner*)
  (html-out "<P>The ~a (STSP) is an extension to the HTTP protocol that allows a LispWeb server to provide services
to other LispWeb servers, or to use the services provided by them. ~%" (bold "Server-To-Server Protocol"))
  (html-out "Thanks to this mechanism, LispWeb servers can become ~a in a distributed computing environment. ~%" (bold "agents"))
  (html-out "<P>The services that a LispWeb server can offer are described in terms of ~a and ~a." (bold "tasks") (bold "actions"))
  (html-out "A task is a set of actions related to the same application; each action is an atomic operation that the client
can request to the server. The general form of an STSP request is the following:~%")
  (html-out (code "<P> STSP &lt;task-name&gt; &lt;action-name&gt; (&lt;arguments&gt;) HTTP/1.0<BR>
&lt;header-field&gt;: &lt;header-content&gt;<BR>
&lt;header-field&gt;: &lt;header-content&gt;<BR>
...<BR>"))
  (html-out "<P>Note that no header field is required by the protocol, but they might be required by specific tasks.
The client must open a TCP connection to the LispWeb server (on the same port used for normal HTTP requests) and send the STSP request
terminated by an empty line. The server sends back an HTTP-style response, whose first line contains the status code telling
whether the request was accepted or not, and for what reasons. ~%")
  (html-out "After this negotiation phase, the request is carried out through a bidirectional message exchange between the client and the server,
until one of the two closes the connection. Obviously, the client must know how to talk to the server's action. To this purpose, the
server can supply the client with a ~a. ~%" (bold "client interface"))
  (html-out "A client interface is a set of functions in a high-level language that are able to talk to the actions of a task. They enable
a client application to use the server's task just as if it were a local task.~%"))

;;; Documentation

(define-page ("Setup Page" :func-name status-page :class :system)
    ()
  (html-out *LispWeb-banner*)
  (html-out (center (header 1 "Server Status<P>")))
  (html-out "LispWeb version ~a built on ~a.<P>~%" *LispWeb-version* *LispWeb-build-date*)
  (html-out "This server was started on ~a, and has received ~d requests.<P>" *startup-date* *request-counter*)
  (html-out "The local date and time are ~a.<p>~%" (http-time))
  ;(html-out "Memory usage: ~a.<P>" (subseq (let ((*standard-output* nil)) (room nil)) 4))
  (html-out (center (header 1 "<HR>Server Control")))
  (html-out (preformatted
	     (in-form (:action (url 'server-control))
		      (html-out "<P>If you are the operator, please supply your password:~%")
		      (html-out "                                       ~a~%" (password-field "password"))
		      (html-out "<P>Change the operator password:          ~a~%" (password-field "new-password-1"))
		      (html-out "<P>Type the new password again:           ~a~%" (password-field "new-password-2"))
		      (html-out "<P>Execute a lisp form inside the server: ~a~%" (text-area "eval-form" 10 40))
		      (html-out "<P>Log server requests:   ~a   to file:   ~a   show it ~a~%"
				(checkbox "log" :value "yes" :checked (when *LispWeb-log-stream* "yes"))
				(text-field "log-stream" :value *LispWeb-log-file*)
				(checkbox "show-log" :value "yes"))
		      (html-out "<P>Log debugger messages: ~a   to file:   ~a   show it ~a~%"
				(checkbox "deb" :value "yes" :checked (when *LispWeb-debug-stream* "yes"))
				(text-field "debug-stream" :value *LispWeb-debug-file*)
				(checkbox "show-deb" :value "yes"))
		      (html-out "<P>Log timing info:       ~a   to file:   ~a   show it ~a~%"
				(checkbox "tim" :value "yes" :checked (when *LispWeb-timing-stream* "yes"))
				(text-field "time-stream" :value *LispWeb-timing-file*)
				(checkbox "show-tim" :value "yes"))
		      (html-out "<P>Change the scheduling delay:           ~a~%" (menu-select "delay" '(0 1 2 5)))
		      (html-out "<P>Use multiple threads:                  ~a~%" (checkbox "threads" :value "yes"
											   :checked (when *http-multithreaded-p* "yes")))
		      (html-out "<P>Reload the initialization file:        ~a~%" (checkbox "reload" :value "yes"))
		      (html-out "<P>Perform garbage collection:            ~a~%" (checkbox "gc" :value "yes"))
		      (html-out "<P>Shut down the server:                  ~a~%" (checkbox "shutdown" :value "yes"))
		      (html-out "<HR>  ~a  ~a~%" (submit-button "Submit") (reset-button "Reset"))))))

(define-page ("Server control" :func-name server-control :class :system)
    ()
  (with-form-fields (password new-password-1 new-password-2 eval-form log 
		     log-stream deb debug-stream tim time-stream delay 
		     threads reload gc shutdown show-log show-deb show-tim)
    (html-out *LispWeb-banner*)
    (cond ((and password
		(check-password password))
	   (when (and (string= new-password-1 new-password-2)
		      (not (string= new-password-1 "")))
	     (setq *operator-password* (encrypt-password new-password-1))
	     (html-out "<P>Changed operator password.~%"))
	   
	   (unless (string= eval-form "")
	     (html-out "Evaluation of the form \'~a\' produced: <P>~a<P>~%" eval-form
		       (plaintext (eval (read-from-string eval-form nil :syntax-error)))))

	   (setq *LispWeb-log-file*
	     (if log			;if turned on
		 (if (equalp "t" log-stream) ;equalp for case-insensitive comparison
		     t			;standard output
		   log-stream)))	;or file; otherwise NIL
	   
	   (setq *LispWeb-debug-file*
	     (when deb			;if turned on
	       (if (equalp "t" debug-stream) ;equalp for case-insensitive comparison
		   t			;standard output
		 debug-stream)))	;or file; otherwise NIL
	   
	   (setq *LispWeb-timing-file*
	     (when tim			;if turned on
	       (if (equalp "t" time-stream) ;equalp for case-insensitive comparison
		   t			;standard output
		 time-stream)))		;or file; otherwise NIL
	   
	   (when delay
	     (setq *http-delay* (read-from-string delay nil nil))
	     (html-out "Scheduling delay set to ~d.<P>~%" *http-delay*))

	   (cond (threads
		  (setq *http-multithreaded-p* t)
		  (html-out "Using multiple threads.<P>~%"))
		 (t (setq *http-multithreaded-p* nil)
		    (html-out "Using single thread.<P>~%")))

	   (when reload
	     (load-init-file)
	     (html-out "<P>Initialization file reloaded.~%"))

	   (init-streams)
	   (if *LispWeb-log-stream*
	       (html-out "<P>Request logging to ~s.~%" (if (stringp *LispWeb-log-file*) *LispWeb-log-file* "standard output"))
	     (html-out "<P>Request logging disabled.~%"))

	   (if *LispWeb-debug-stream*
	       (html-out "<P>Debug output to ~s.~%" (if (stringp *LispWeb-debug-file*) *LispWeb-debug-file* "standard output"))
	     (html-out "<P>Debugging disabled.~%"))

	   (if *LispWeb-timing-stream*
	       (html-out "<P>Time logging to ~s.~%" (if (stringp *LispWeb-timing-file*) *LispWeb-timing-file* "standard output"))
	     (html-out "<P>Time logging disabled.~%"))

	   (when gc
	     (gc)
	     (html-out "<P>Garbage Collection performed.~%"))

	   (when shutdown
	     (setq *closing-server* t)
	     (html-out "<P>Server shut down.~%"))
	   
	   (when (and show-log
		      (stringp *LispWeb-log-file*))
	     (html-out "<P>Contents of log file:")
	     (html-out (preformatted 
			(include (format nil "~a" (merge-pathnames *LispWeb-log-file* *LispWeb-conf-dir*))))))
	   (when (and show-deb
		      (stringp *LispWeb-debug-file*))
	     (html-out "<P>Contents of debug log file:")
	     (html-out (preformatted 
			(include (format nil "~a" (merge-pathnames *LispWeb-debug-file* *LispWeb-conf-dir*))))))
	   (when (and show-tim
		      (stringp *LispWeb-timing-file*))
	     (html-out "<P>Contents of timing log file:")
	     (html-out (preformatted 
			(include (format nil "~a" (merge-pathnames *LispWeb-timing-file* *LispWeb-conf-dir*)))))))
    
	  (t (html-out "You did not supply the correct operator password. You are not authorized to change the server parameters.<P>~%")))
    (html-out "<HR><H4>Go back to the ~a</H4>~%" (anchor "/" "top page"))))

;;; System forms

(define-page ("Lisp Source Page" :func-name view-source-page
			       :class :system
			       :visible t)
    (request)
  (let ((func (intern request (find-package :lu))))
    (html-out (header 4 (html-build "<p>This is the Lisp source generating the ~a page:" (bold request))))
    (html-out "<p>~a</p>" (plaintext (html::marlowe-pprint (get func :hall-source))))
    (html-out "<HR><p>~a</p>"
	      (italic (format nil "This page was generated by ~a."
			      (page-anchor 'marlowe "Marlowe"))))))

;;; Example

(define-page ("Comment form" :func-name comment-page :class :system) 
    ()
  (html-out *LispWeb-banner*)
  (html-out (center (header 1 "Comment form")))
  (html-out (in-form (:action (url 'thanks-page))
		     (html-out "Please enter your comments in the space below:<P>~%")
		     (html-out "~a<P>~%" (text-area "comments" 10 60))
		     (html-out "Please enter your name: ~A<P>~%" (text-field "realname"))
		     (html-out "Please enter your e-mail address: ~A<P>~%" (text-field "email"))
		     (html-out "<HR>  ~a  ~a~%" (submit-button "Submit") (reset-button "Reset")))))

(define-page ("Thank You!" :func-name thanks-page :class :system)
    ()
  (with-field-value (realname email comments)
    (send-mail "LispWeb-user" 
	       *operator-address* 
	       (format nil "~a (~a from ~a) writes:~%~%~a" realname
		       email
		       (http-info-addr *http-info*)
		       comments))
    (html-out "Comments received from ~a (~a). Thank you!~%<P>" realname email)
    (html-out "<HR><H4>Go back to the ~a</H4>~%" (anchor "/" "top page"))))

(define-page ("Page Inspector" :func-name page-inspector :class :system)
    (&optional name)
  (if name
      (let ((func-name (read-from-string name)))
	(case (get func-name :lispweb-fun-type)
	  (:dispatch 
	   (progn (html-out (center (header 1 (format nil "The ~a application" name))))
		  (html-out (center 
			     (header 2 (format nil "Father application: ~a" 
					       (page-anchor 'page-inspector 
							    (get func-name :lispweb-class)
							    :args (unless (member (get func-name :lispweb-class) 
										  '(:user :system))
								    (list (get func-name :lispweb-class)))
							    :full t)))))
		  
		  (html-out (dotted-list 
			     (mapcar #'(lambda (pair)
					 (page-anchor 'page-inspector 
						      (car pair) 
						      :args (list (cdr pair)) 
						      :full t))
				     (symbol-value func-name))))))
	  (:page (let ((app (get func-name :lispweb-class)))
		   (html-out (center (header 1 (format nil "The ~a page" name))))
		   (html-out (center 
			      (header 2 (format nil "Application: ~a" 
						(page-anchor 'page-inspector 
							     app
							     :args (unless (member app '(:user :system))
								     (list app))
							     :full t)))))))))
    (progn
      (html-out *LispWeb-banner*)
      (html-out (center (header 1 "Page Inspector")))
      (html-out (header 2 "User pages:"))
      (html-out (dotted-list 
		 (mapcar #'(lambda (pair)
			     (page-anchor 'page-inspector (car pair) :args (list (cdr pair))))
			 *user-pages*)))
      (html-out (header 2 "System pages:"))
      (html-out (dotted-list 
		 (mapcar #'(lambda (pair)
			     (page-anchor 'page-inspector (car pair) :args (list (cdr pair))))
			 *system-pages*))))))

